function Group:CreateOptionMenu()
    self.Options = UI:Create( "WINDOW", nil, function( main )
        main:SetSize( 1218, 848  )
        main:SetPos( UI.SCREEN_W / 2 - 1218 / 2, UI.SCREEN_H / 2 - 848 / 2 )
        main:SetWantsKeyEvents( true )

        UI:Create( "BOX", main, function( ui )
            ui:SetSize( 219, 27 )
            ui:SetPos( 1218 / 2 - 219 / 2, 3 )
            ui:SetColor( 100, 100, 100 )

            UI:Create( "BOX", ui, function( ui )
                ui:SetPos( 1, 1 )
                ui:SetSize( 217, 25 )
                ui:SetColor( 25, 25, 25 )
            end )

            UI:Create( "TEXT", ui, function( ui )
                ui:SetSize( 219, 27 )
                ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro20 )
                ui:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )
                ui:SetText( "MiniRaid Options" )
            end )
        end )

        main.ui_toggle    = false
        main.save_visible = main:IsVisible()

        function main:KeyDown( key )
            if key.Action == Turbine.UI.Lotro.Action.Escape then
                if self.ui_toggle then
                    self.ui_toggle = false

                    self:SetVisible( self.save_visible )
                else
                    self:SetVisible( false )
                end
            elseif key.Action == Turbine.UI.Lotro.Action.UI_Toggle then
                self.disable_changed = true
    
                if self.ui_toggle then
                    self:SetVisible( self.save_visible )
                else
                    self:SetVisible( false )
                end
    
                self.disable_changed = false
    
                self.ui_toggle = not self.ui_toggle
            end
        end
    
        function main:VisibleChanged()
            if not self.disable_changed then
                self.save_visible = self:IsVisible()
            end
        end

        main.scroll = UI:Create( "SCROLLBOX", main, function( ui )
            ui:SetSize( 360 * 2 + 16 * 2 + 1 + UI.Spacing + 16 + 10, 800 - 22 - 38 + 34 + 12 )
            ui:SetPos( 22, 38 )

            ui.container =  ui:Insert( 
                UI:Create( "BOX", ui.list, function( ui ) --Add Two seperate scrollbars instead of 1 for both columns?
                    ui:SetWidth( 360 * 2 + 16 * 2 + 1 )
                    ui:SetColor( 0, 0, 100, 0 )
                    ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                    main.leftBar = UI:Create( "LIST", ui, function( ui )
                        ui:SetWidth( 360 )
                        --ui:SetColor( 200, 100, 100, 200 )
                    end )

                    function ui:SizeChanged()
                        self.divider:SetHeight( self:GetHeight() )
                    end

                    ui.divider = UI:Create( "BOX", ui, function( ui )
                        ui:SetWidth( 1 )
                        ui:SetPos( 360 + 16, 0 )
                        ui:SetColor( 100, 100, 100 )
                    end )

                    main.rightBar = UI:Create( "LIST", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetPos( 360 + 16 * 2 + 1, 0 )
                        --ui:SetColor( 200, 100, 100, 200 )
                    end )
                end )
            )


            for i = 1, 40 do --Damn hacky way, to fix the listbox shortcomings without making a custom scrollbar from scratch.
                ui:Insert(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 0, 0 )
                    end )
                )
            end
        end )

        main.sideBar = UI:Create( "LIST", main, function( ui )
            ui:SetSize( 360, 2000 )
            ui:SetPos( 836, 38 )
        end )

        UI:Create( "BOX", main, function( ui )
            ui:SetSize( 1, 800 - 38 - 22 + 34 + 12 )
            ui:SetPos( 22 + 360 * 2 + 16 * 2 + 1 + UI.Spacing + 16 + UI.Spacing + 20, 38 )
            ui:SetColor( 100, 100, 100 )
        end )

        --Group Layout
        main.leftBar:AddItem(
            UI:Create( "LIST", main.leftBar, function( ui )
                ui:SetWidth( 360 )
                ui:SetColor( 200, 0, 0, 0 )
                ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )
        
                ui:AddItem(
                    UI:Create( "HEADER", ui, function( ui )
                        ui:SetText( "Group Layout" )
                    end )
                )

                main.slider_x = {}
                main.slider_y = {}

                ui:AddFiller( 0, 16 )

                --Layout
                for i = 1, 5 do
                    ui:AddItem(
                        UI:Create( "BOX", ui, function( ui )
                            ui:SetSize( 360, 32 + UI.Spacing )
                            ui:SetColor( 0, 0, 100, 0 )
                            ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                            UI:Create( "TEXT", ui, function( ui )
                                ui:SetSize( 56, 16 )
                                ui:SetPos( 360 - 56, 0 )
                                ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                                ui:SetText( Group.Settings.Layout[ i ].min .. " - " .. Group.Settings.Layout[ i ].max )
                                ui:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )
                            end )
                    
                            main.slider_x[ i ] = UI:Create( "SLIDER", ui, function( ui )
                                ui:SetWidth( 360 - 56 - UI.Spacing )
                                ui:SetRange( 1, Group.Settings.Layout[ i ].max )
                                ui:SetValue( Group.Settings.Layout[ i ].x )
                                ui:SetKey( "X" )
                    
                                function ui:ValueChanged( value )
                                    local new = math.ceil( Group.Settings.Layout[ i ].max / value )
                    
                                    Group.Settings.Layout[ i ].x = value
                                    Group.Settings.Layout[ i ].y = new
                    
                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                    
                                    main.slider_y[ i ]:SetValue( new, true )
                                    main.slider_y[ i ]:SetText( new )
                    
                                    if Group.PartyCount > 1 then
                                        Group:DefineGridLayout( Group.PartyCount )
                                        Group:RefreshLayout()
                                    end

                                    if main.enable_layout_preview then
                                        PartyVitals:DefinePreviewLayout( PartyVitals.preview_count )
                                        PartyVitals:RefreshPreview()
                                    end
                                end
                    
                                function ui:SliderChanged( value )
                                    local new = math.ceil( Group.Settings.Layout[ i ].max / value )
                    
                                    Group.Settings.Layout[ i ].x = value
                                    Group.Settings.Layout[ i ].y = new
                    
                                    main.slider_y[ i ]:SetValue( new, true )
                                    main.slider_y[ i ]:SetText( new )
                    
                                    if Group.PartyCount > 1 then
                                        Group:DefineGridLayout( Group.PartyCount )
                                        Group:RefreshLayout()
                                    end

                                    if main.enable_layout_preview then
                                        PartyVitals:DefinePreviewLayout( PartyVitals.preview_count )
                                        PartyVitals:RefreshPreview()
                                    end
                                end
                            end )

                            main.slider_y[ i ] = UI:Create( "SLIDER_RESET", ui, function( ui )
                                ui:SetPos( 0, 16 + UI.Spacing )
                                ui:SetWidth( 360 )
                                ui:SetRange( 1, Group.Settings.Layout[ i ].max )
                                ui:SetValue( Group.Settings.Layout[ i ].y )
                                ui:SetKey( "Y" )
                
                                function ui:ValueChanged( value )
                                    local new = math.ceil( Group.Settings.Layout[ i ].max / value )
                    
                                    Group.Settings.Layout[ i ].x = new
                                    Group.Settings.Layout[ i ].y = value
                    
                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                    
                                    main.slider_x[ i ]:SetValue( new, true )
                                    main.slider_x[ i ]:SetText( new )
                    
                                    if Group.PartyCount > 1 then
                                        Group:DefineGridLayout( Group.PartyCount )
                                        Group:RefreshLayout()
                                    end

                                    if main.enable_layout_preview then
                                        PartyVitals:DefinePreviewLayout( PartyVitals.preview_count )
                                        PartyVitals:RefreshPreview()
                                    end
                                end
                    
                                function ui:SliderChanged( value )
                                    local new = math.ceil( Group.Settings.Layout[ i ].max / value )
                    
                                    Group.Settings.Layout[ i ].x = new
                                    Group.Settings.Layout[ i ].y = value
                    
                                    main.slider_x[ i ]:SetValue( new, true )
                                    main.slider_x[ i ]:SetText( new )
                    
                                    if Group.PartyCount > 1 then
                                        Group:DefineGridLayout( Group.PartyCount )
                                        Group:RefreshLayout()
                                    end

                                    if main.enable_layout_preview then
                                        PartyVitals:DefinePreviewLayout( PartyVitals.preview_count )
                                        PartyVitals:RefreshPreview()
                                    end
                                end
            
                                function ui:Reset()
                                    Group.Settings.Layout[ i ].x = Group.Default_Settings.Layout[ i ].x
                                    Group.Settings.Layout[ i ].y = Group.Default_Settings.Layout[ i ].y
                    
                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                    
                                    main.slider_x[ i ]:SetValue( Group.Default_Settings.Layout[ i ].x, true )
                                    main.slider_x[ i ]:SetText( Group.Default_Settings.Layout[ i ].x )
                                    self:SetValue( Group.Default_Settings.Layout[ i ].y, true )
                                    self:SetText( Group.Default_Settings.Layout[ i ].y )
                    
                                    if Group.PartyCount > 1 then
                                        Group:DefineGridLayout( Group.PartyCount )
                                        Group:RefreshLayout()
                                    end

                                    if main.enable_layout_preview then
                                        PartyVitals:DefinePreviewLayout( PartyVitals.preview_count )
                                        PartyVitals:RefreshPreview()
                                    end
                                end
                            end )
                        end )
                    )

                    ui:AddFiller( 0, 16 )
                end

                --Spacing
                ui:AddItem(
                    UI:Create( "SLIDER_RESET", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetKey( "Spacing" )
                        ui:SetRange( 0, 128 )
                        ui:SetValue( Group.Settings.vitals_external_spacing )
                        ui:SetKeySize( 63 )

                        function ui:ValueChanged( value )
                            Group.Settings.vitals_external_spacing = value

                            if Group.PartyCount > 1 then
                                Group:RefreshLayout()
                            end

                            if main.enable_layout_preview then
                                PartyVitals:RefreshPreview()
                            end

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                        end

                        function ui:SliderChanged( value )
                            Group.Settings.vitals_external_spacing = value

                            if Group.PartyCount > 1 then
                                Group:RefreshLayout()
                            end

                            if main.enable_layout_preview then
                                PartyVitals:RefreshPreview()
                            end
                        end

                        function ui:Reset()
                            self:SetValue( Group.Default_Settings.vitals_external_spacing )
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Horizontal Layout Direction" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )
                
                --Horizontal Layout Direction
                ui:AddItem(
                    UI:Create( "DROPDOWN", ui, function( ui )
                        ui:SetWidth( 360 )

                        local tbl = {
                            "Left",
                            "Center",
                            "Right"
                        }

                        for i = 1, #tbl do
                            local item = ui:Add( tbl[ i ], function()
                                Group.Settings.horizontal_layout_direction = i

                                if main.enable_layout_preview then
                                    PartyVitals:RefreshPreview()
                                end
            
                                if Group.PartyCount > 0 then
                                    Group:RefreshLayout()
                                end
            
                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            end )

                            if i == Group.Settings.horizontal_layout_direction then
                                ui:SetSelected( item )
                            end
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Vertical Layout Direction" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Vertical Layout Direction
                ui:AddItem(
                    UI:Create( "DROPDOWN", ui, function( ui )
                        ui:SetWidth( 360 )

                        local tbl = {
                            "Top",
                            "Bottom"
                        }

                        for i = 1, #tbl do
                            local item = ui:Add( tbl[ i ], function()
                                Group.Settings.vertical_layout_direction = i

                                if main.enable_layout_preview then
                                    PartyVitals:RefreshPreview()
                                end
            
                                if Group.PartyCount > 0 then
                                    Group:RefreshLayout()
                                end
            
                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            end )

                            if i == Group.Settings.vertical_layout_direction then
                                ui:SetSelected( item )
                            end
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Position" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                ui:AddItem(
                    UI:Create( "SLIDER_RESET", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetRange( 0, UI.SCREEN_W )
                        ui:SetValue( Group.Settings.Pos.x )
                        ui:SetKey( "X" )
                        ui:SetResetText( "Center" )
                        ui:SetValueSize( 32 )
                        ui:SetButtonSize( 64 )
        
                        function ui:ValueChanged( value )
                            Group.Settings.Pos.x = value
        
                            PartyVitals:SetPos( Group.Settings.Pos.x - ( UI.SCREEN_W * 2 ) / 2, Group.Settings.Pos.y - ( UI.SCREEN_H * 2 ) / 2 )
        
                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                        end
        
                        function ui:SliderChanged( value )
                            Group.Settings.Pos.x = value
        
                            PartyVitals:SetPos( Group.Settings.Pos.x - ( UI.SCREEN_W * 2 ) / 2, Group.Settings.Pos.y - ( UI.SCREEN_H * 2 ) / 2 )
                        end

                        function ui:Reset()
                            self:SetValue( Group.Default_Settings.Pos.x )
                        end
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                ui:AddItem(
                    UI:Create( "SLIDER_RESET", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetRange( 0, UI.SCREEN_H )
                        ui:SetValue( Group.Settings.Pos.y )
                        ui:SetKey( "Y" )
                        ui:SetResetText( "Center" )
                        ui:SetValueSize( 32 )
                        ui:SetButtonSize( 64 )
        
                        function ui:ValueChanged( value )
                            Group.Settings.Pos.y = value
        
                            PartyVitals:SetPos( Group.Settings.Pos.x - ( UI.SCREEN_W * 2 ) / 2, Group.Settings.Pos.y - ( UI.SCREEN_H * 2 ) / 2 )
        
                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                        end
        
                        function ui:SliderChanged( value )
                            Group.Settings.Pos.y = value
        
                            PartyVitals:SetPos( Group.Settings.Pos.x - ( UI.SCREEN_W * 2 ) / 2, Group.Settings.Pos.y - ( UI.SCREEN_H * 2 ) / 2 )
                        end

                        function ui:Reset()
                            self:SetValue( Group.Default_Settings.Pos.y )
                        end
                    end )
                )

                ui:SetHeightToChildren( 16 )
            end )
        )

        --Frame
        main.leftBar:AddItem(
            UI:Create( "LIST", main.leftBar, function( ui )
                ui:SetWidth( 360 )
                ui:SetColor( 200, 0, 0, 0 )
                ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                ui:AddItem(
                    UI:Create( "HEADER", ui, function( ui )
                        ui:SetText( "Frame" )
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Frame Size" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Frame Width
                ui:AddItem(
                    UI:Create( "SLIDER_RESET", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetRange( 16, 256 )
                        ui:SetValue( Group.Settings.vitals_x )
                        ui:SetKey( "X" )

                        function ui:ValueChanged( value )
                            Group.Settings.vitals_x = value

                            main.Frame:SetSize( Group.Settings.vitals_x, Group.Settings.vitals_y )
                            main.Frame:SetPos( 360 / 2 - Group.Settings.vitals_x / 2, 360 / 2 - Group.Settings.vitals_y / 2 )

                            for i = 1, #Group.Party do
                                Group.Party[ i ]:SetWidth( value )
                                Group.Party[ i ]:SizeChanged()
                            end

                            Group:RefreshLayout()

                            if main.enable_layout_preview then
                                for i = 1, 24 do
                                    PartyVitals.preview[ i ]:SetWidth( value )
                                end

                                PartyVitals:RefreshPreview()
                            end

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                        end

                        function ui:SliderChanged( value )
                            Group.Settings.vitals_x = value

                            main.Frame:SetSize( Group.Settings.vitals_x, Group.Settings.vitals_y )
                            main.Frame:SetPos( 360 / 2 - Group.Settings.vitals_x / 2, 360 / 2 - Group.Settings.vitals_y / 2 )

                            for i = 1, #Group.Party do
                                Group.Party[ i ]:SetWidth( value )
                                Group.Party[ i ]:SizeChanged()
                            end

                            Group:RefreshLayout()

                            if main.enable_layout_preview then
                                for i = 1, 24 do
                                    PartyVitals.preview[ i ]:SetWidth( value )
                                end
                                
                                PartyVitals:RefreshPreview()
                            end
                        end

                        function ui:Reset()
                            self:SetValue( Group.Default_Settings.vitals_x )
                        end
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Frame Height
                ui:AddItem(
                    UI:Create( "SLIDER_RESET", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetRange( 16, 256 )
                        ui:SetValue( Group.Settings.vitals_y )
                        ui:SetKey( "Y" )

                        function ui:ValueChanged( value )
                            Group.Settings.vitals_y = value

                            main.Frame:SetSize( Group.Settings.vitals_x, Group.Settings.vitals_y )
                            main.Frame:SetPos( 360 / 2 - Group.Settings.vitals_x / 2, 360 / 2 - Group.Settings.vitals_y / 2 )

                            for i = 1, #Group.Party do
                                Group.Party[ i ]:SetHeight( value )
                            end

                            Group:RefreshLayout()

                            if main.enable_layout_preview then
                                for i = 1, 24 do
                                    PartyVitals.preview[ i ]:SetHeight( value )
                                end
                                
                                PartyVitals:RefreshPreview()
                            end

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                        end

                        function ui:SliderChanged( value )
                            Group.Settings.vitals_y = value

                            main.Frame:SetSize( Group.Settings.vitals_x, Group.Settings.vitals_y )
                            main.Frame:SetPos( 360 / 2 - Group.Settings.vitals_x / 2, 360 / 2 - Group.Settings.vitals_y / 2 )

                            for i = 1, #Group.Party do
                                Group.Party[ i ]:SetHeight( value )
                            end

                            Group:RefreshLayout()

                            if main.enable_layout_preview then
                                for i = 1, 24 do
                                    PartyVitals.preview[ i ]:SetHeight( value )
                                end
                                
                                PartyVitals:RefreshPreview()
                            end
                        end

                        function ui:Reset()
                            self:SetValue( Group.Default_Settings.vitals_y )
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Power Bar Width" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Power Width
                ui:AddItem(
                    UI:Create( "SLIDER_RESET", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetRange( 0, 128 )
                        ui:SetValue( Group.Settings.power_x )
                        ui:SetKey( "" )
                        ui:SetKeySize( 0 )

                        function ui:ValueChanged( value )
                            Group.Settings.power_x = value

                            main.Frame.power:SetWidth( value )
                            main.Frame:SizeChanged()

                            for i = 1, #Group.Party do
                                Group.Party[ i ].morale:SetPos( value, 0 )
                                Group.Party[ i ].power:SetWidth( value )
                                Group.Party[ i ]:SizeChanged()
                            end

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                        end

                        function ui:SliderChanged( value )
                            Group.Settings.power_x = value

                            main.Frame.power:SetWidth( value )
                            main.Frame:SizeChanged()

                            for i = 1, #Group.Party do
                                Group.Party[ i ].morale:SetPos( value, 0 )
                                Group.Party[ i ].power:SetWidth( value )
                                Group.Party[ i ]:SizeChanged()
                            end
                        end

                        function ui:Reset()
                            self:SetValue( Group.Default_Settings.power_x )
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Selection Size" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Selection Thickness
                ui:AddItem(
                    UI:Create( "SLIDER_RESET", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetRange( 0, 16 )
                        ui:SetValue( Group.Settings.selection_size )
                        ui:SetKey( "" )
                        ui:SetKeySize( 0 )

                        function ui:ValueChanged( value )
                            Group.Settings.selection_size = value

                            for i = 1, #Group.Party do
                                Group.Party[ i ].selection:SetBorderSize( value )
                            end

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                        end

                        function ui:SliderChanged( value )
                            Group.Settings.selection_size = value

                            for i = 1, #Group.Party do
                                Group.Party[ i ].selection:SetBorderSize( value )
                            end
                        end

                        function ui:Reset()
                            self:SetValue( Group.Default_Settings.selection_size )
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "DIVIDER", ui, function( ui )
                    end )
                )

                local object = {
                    Name           = function()
                        main.Pos[ Group.Settings.Frame.Name.anchor ]( main.Frame.name, Group.Settings.Frame.Name.x, Group.Settings.Frame.Name.y, main.Frame.name:GetSize() ) 
                        
                        if Group.Settings.Frame.Name.anchor == 1 or Group.Settings.Frame.Name.anchor == 4 then
                            main.Frame.name:SetTextAlignment( 4 )

                            for i = 1, #Group.Party do
                                Group.Party[ i ].Pos[ Group.Settings.Frame.Name.anchor ]( Group.Party[ i ].name, Group.Settings.Frame.Name.x, Group.Settings.Frame.Name.y, Group.Party[ i ].name:GetSize() ) 
                                Group.Party[ i ].name:SetTextAlignment( 4 )
                            end
                        elseif Group.Settings.Frame.Name.anchor == 5 then
                            main.Frame.name:SetTextAlignment( 5 )

                            for i = 1, #Group.Party do
                                Group.Party[ i ].Pos[ Group.Settings.Frame.Name.anchor ]( Group.Party[ i ].name, Group.Settings.Frame.Name.x, Group.Settings.Frame.Name.y, Group.Party[ i ].name:GetSize() ) 
                                Group.Party[ i ].name:SetTextAlignment( 5 )
                            end
                        else
                            main.Frame.name:SetTextAlignment( 6 )

                            for i = 1, #Group.Party do
                                Group.Party[ i ].Pos[ Group.Settings.Frame.Name.anchor ]( Group.Party[ i ].name, Group.Settings.Frame.Name.x, Group.Settings.Frame.Name.y, Group.Party[ i ].name:GetSize() ) 
                                Group.Party[ i ].name:SetTextAlignment( 6 )
                            end
                        end
                    end,
                    Class          = function() 
                        main.Pos[ Group.Settings.Frame.Class.anchor ]( main.Frame.class, Group.Settings.Frame.Class.x, Group.Settings.Frame.Class.y, Group.Settings.class_icon_size, Group.Settings.class_icon_size ) 

                        for i = 1, #Group.Party do
                            Group.Party[ i ].Pos[ Group.Settings.Frame.Class.anchor ]( Group.Party[ i ].class, Group.Settings.Frame.Class.x, Group.Settings.Frame.Class.y, Group.Settings.class_icon_size, Group.Settings.class_icon_size )
                        end
                    end,
                    Leader         = function() 
                        main.Pos[ Group.Settings.Frame.Leader.anchor ]( main.Frame.leader, Group.Settings.Frame.Leader.x, Group.Settings.Frame.Leader.y, Group.Settings.leader_icon_size, Group.Settings.leader_icon_size ) 
                    
                        for i = 1, #Group.Party do
                            Group.Party[ i ].Pos[ Group.Settings.Frame.Leader.anchor ]( Group.Party[ i ].leader, Group.Settings.Frame.Leader.x, Group.Settings.Frame.Leader.y, Group.Settings.leader_icon_size, Group.Settings.leader_icon_size )
                        end
                    end,
                    Morale_Text    = function() 
                        main.Pos[ Group.Settings.Frame.Morale_Text.anchor ]( main.Frame.morale.text, Group.Settings.Frame.Morale_Text.x, Group.Settings.Frame.Morale_Text.y, main.Frame.morale.text:GetSize() )

                        if Group.Settings.Frame.Morale_Text.anchor == 1 or Group.Settings.Frame.Morale_Text.anchor == 4 then
                            main.Frame.morale.text:SetTextAlignment( 4 )

                            for i = 1, #Group.Party do
                                Group.Party[ i ].Pos[ Group.Settings.Frame.Morale_Text.anchor ]( Group.Party[ i ].morale.text, Group.Settings.Frame.Morale_Text.x, Group.Settings.Frame.Morale_Text.y, Group.Party[ i ].morale.text:GetSize() ) 
                                Group.Party[ i ].name:SetTextAlignment( 4 )
                            end
                        elseif Group.Settings.Frame.Morale_Text.anchor == 5 then
                            main.Frame.morale.text:SetTextAlignment( 5 )

                            for i = 1, #Group.Party do
                                Group.Party[ i ].Pos[ Group.Settings.Frame.Morale_Text.anchor ]( Group.Party[ i ].morale.text, Group.Settings.Frame.Morale_Text.x, Group.Settings.Frame.Morale_Text.y, Group.Party[ i ].morale.text:GetSize() ) 
                                Group.Party[ i ].name:SetTextAlignment( 5 )
                            end
                        else
                            main.Frame.morale.text:SetTextAlignment( 6 )

                            for i = 1, #Group.Party do
                                Group.Party[ i ].Pos[ Group.Settings.Frame.Morale_Text.anchor ]( Group.Party[ i ].morale.text, Group.Settings.Frame.Morale_Text.x, Group.Settings.Frame.Morale_Text.y, Group.Party[ i ].morale.text:GetSize() ) 
                                Group.Party[ i ].name:SetTextAlignment( 6 )
                            end
                        end
                    end,
                    Effect         = function() 
                        main.Frame:EffectLayout() 

                        for i = 1, #Group.Party do
                            Group.Party[ i ]:EffectLayout()
                        end
                    end,
                    Special_Effect = function() 
                        main.Pos[ Group.Settings.Frame.Special_Effect.anchor ]( main.Frame.special, Group.Settings.Frame.Special_Effect.x, Group.Settings.Frame.Special_Effect.y ) 

                        for i = 1, #Group.Party do
                            Group.Party[ i ].Pos[ Group.Settings.Frame.Special_Effect.anchor ]( Group.Party[ i ].special, Group.Settings.Frame.Special_Effect.x, Group.Settings.Frame.Special_Effect.y )
                        end
                    end
                }

                local tbl = {
                    "Name",
                    "Class", 
                    "Leader", 
                    "Morale_Text", 
                    "Effect",
                    "Special_Effect"
                }

                main.FrameObject = {}

                for i = 1, #tbl do
                    ui:AddFiller( 0, 16 )

                    local k = tbl[ i ]
                    local v = Group.Settings.Frame[ k ]

                    main.FrameObject[ k ] = {}

                    ui:AddItem(
                        UI:Create( "LIST", ui, function( ui )
                            ui:SetSize( 360, 16 * 3 + UI.Spacing * 3 + 24 )

                            UI:Create( "TEXT", ui, function( ui )
                                ui:SetSize( 360, 16 )
                                ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                                ui:SetText( string.gsub( k, "_", " " ) )
                            end )

                            UI:Create( "BUTTON", ui, function( ui )
                                ui:SetPos( 360 - 56, 16 + UI.Spacing )
        
                                function ui:Pressed()
                                    local anchor = Group.Default_Settings.Frame[ k ].anchor

                                    main.FrameObject[ k ].anchor:SetSelected( main.FrameObject[ k ].anchor.list[ anchor ] )

                                    v.anchor = anchor

                                    main.FrameObject[ k ].x:SetValue( Group.Default_Settings.Frame[ k ].x )
                                    main.FrameObject[ k ].y:SetValue( Group.Default_Settings.Frame[ k ].y )

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                end
                            end )
                            
                            main.FrameObject[ k ].x = UI:Create( "SLIDER", ui, function( ui )
                                ui:SetPos( 0, 16 + UI.Spacing )
                                ui:SetWidth( 300 )
                                ui:SetKey( "X" )
                                ui:SetRange( 0, 256 )
                                ui:SetValueSize( 32 )

                                if Group.Settings.Frame[ k ].anchor == 5 then
                                    ui:SetValue( v.x + 256 / 2 )
                                    ui:SetText( v.x )
                                else
                                    ui:SetValue( v.x )
                                end
        
                                function ui:ValueChanged( value )
                                    if Group.Settings.Frame[ k ].anchor == 5 then
                                        value = value - 256 / 2

                                        self:SetText( value )
                                    end

                                    v.x = value

                                    object[ k ]()
        
                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                end
        
                                function ui:SliderChanged( value )
                                    if Group.Settings.Frame[ k ].anchor == 5 then
                                        value = value - 256 / 2

                                        self:SetText( value )
                                    end

                                    v.x = value

                                    object[ k ]()
                                end
                            end )

                            main.FrameObject[ k ].y = UI:Create( "SLIDER", ui, function( ui )
                                ui:SetPos( 0, ( 16 + UI.Spacing ) * 2 )
                                ui:SetWidth( 300 )
                                ui:SetKey( "Y" )
                                ui:SetRange( 0, 256 )
                                ui:SetValueSize( 32 )

                                if Group.Settings.Frame[ k ].anchor == 5 then
                                    ui:SetValue( v.y + 256 / 2 )
                                    ui:SetText( v.y )
                                else
                                    ui:SetValue( v.y )
                                end
        
                                function ui:ValueChanged( value )
                                    if Group.Settings.Frame[ k ].anchor == 5 then
                                        value = value - 256 / 2

                                        self:SetText( value )
                                    end
                                    
                                    v.y = value

                                    object[ k ]()
        
                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                end
        
                                function ui:SliderChanged( value )
                                    if Group.Settings.Frame[ k ].anchor == 5 then
                                        value = value - 256 / 2

                                        self:SetText( value )
                                    end
                                    
                                    v.y = value

                                    object[ k ]()
                                end
                            end )

                            UI:Create( "TEXT", ui, function( ui )
                                ui:SetPos( 0, ( 16 + UI.Spacing ) * 3 )
                                ui:SetSize( 160, 24 )
                                ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                                ui:SetText( "Anchor Point" )
                                ui:SetTextAlignment( 4 )
                            end )

                            main.FrameObject[ k ].anchor = UI:Create( "DROPDOWN", ui, function( ui )
                                ui:SetPos( 123, ( 16 + UI.Spacing ) * 3 )
                                ui:SetWidth( 237 )
        
                                local tbl = {
                                    "Top Left",
                                    "Top Right",
                                    "Bottom Right",
                                    "Bottom Left",
                                    "Center"
                                }

                                ui.list = {}
        
                                for i = 1, #tbl do
                                    if i == 5 and k == "Effect" then break end

                                    local item = ui:Add( tbl[ i ], function()
                                        v.anchor = i

                                        if tbl[ i ] == "Center" then 
                                            main.FrameObject[ k ].x:SetValue( 256 / 2 )
                                            main.FrameObject[ k ].y:SetValue( 256 / 2 )
                                        else
                                            main.FrameObject[ k ].x:SetValue( 0 )
                                            main.FrameObject[ k ].y:SetValue( 0 )
                                        end

                                        object[ k ]()
                    
                                        Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
        
                                    end )
        
                                    if i == v.anchor then
                                        ui:SetSelected( item )
                                    end

                                    ui.list[ i ] = item
                                end
                            end )
                        end )
                    )

                    if k == "Name" then
                        ui:AddFiller( 0, 16 )

                        ui:AddItem(
                            UI:Create( "TEXT", ui, function( ui )
                                ui:SetSize( 360, 16 )
                                ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                                ui:SetText( "Name Width" )

                                UI:Create( "TEXT", ui, function( ui )
                                    ui:SetPos( -16 - UI.Spacing, 0 )
                                    ui:SetSize( 360, 16 )
                                    ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                                    ui:SetText( "Show Bounds" )
                                    ui:SetTextAlignment( 6 )
                                end )

                                UI:Create( "CHECKBOX", ui, function( ui )
                                    ui:SetSize( 16, 16 )
                                    ui:SetPos( 360 - 16, 0 )
                                    ui:SetChecked( false )
        
                                    function ui:CheckedChanged()
                                        local checked = self:IsChecked()

                                        if checked then
                                            main.Frame.name:SetColor( 200, 0, 0, 100 )
                                        else
                                            main.Frame.name:SetColor( 0, 0, 0, 0 )
                                        end
                                    end
                                end )
                            end )
                        )

                        ui:AddFiller( 0, UI.Spacing )

                        --Name Width
                        ui:AddItem(
                            UI:Create( "SLIDER_RESET", ui, function( ui )
                                ui:SetWidth( 360 )
                                ui:SetRange( 0, 256 )
                                ui:SetValue( Group.Settings.name_width )
                                ui:SetKey( "" )
                                ui:SetKeySize( 0 )

                                function ui:ValueChanged( value )
                                    Group.Settings.name_width = value

                                    main.Frame.name:SetWidth( value )

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].name:SetWidth( value )
                                    end

                                    object[ k ]()

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                end

                                function ui:SliderChanged( value )
                                    Group.Settings.name_width = value

                                    main.Frame.name:SetWidth( value )

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].name:SetWidth( value )
                                    end

                                    object[ k ]()
                                end

                                function ui:Reset()
                                    self:SetValue( Group.Default_Settings.name_width )
                                end
                            end )
                        )

                        ui:AddFiller( 0, 16 )

                        ui:AddItem(
                            UI:Create( "DIVIDER", ui, function( ui )
                            end )
                        )
                    end

                    if k == "Class" then
                        ui:AddFiller( 0, 16 )

                        ui:AddItem(
                            UI:Create( "TEXT", ui, function( ui )
                                ui:SetSize( 360, 16 )
                                ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                                ui:SetText( "Icon Size" )
                            end )
                        )

                        ui:AddFiller( 0, UI.Spacing )

                        --Class Icon Size
                        ui:AddItem(
                            UI:Create( "SLIDER_RESET", ui, function( ui )
                                ui:SetWidth( 360 )
                                ui:SetRange( 4, 32 )
                                ui:SetValue( Group.Settings.class_icon_size )
                                ui:SetKey( "" )
                                ui:SetKeySize( 0 )

                                function ui:ValueChanged( value )
                                    Group.Settings.class_icon_size = value

                                    main.Frame.class:SetStretchMode( 1 )
                                    main.Frame.class:SetSize( value, value )

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].class:SetStretchMode( 1 )
                                        Group.Party[ i ].class:SetSize( value, value )
                                    end

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                end

                                function ui:SliderChanged( value )
                                    Group.Settings.class_icon_size = value

                                    main.Frame.class:SetStretchMode( 1 )
                                    main.Frame.class:SetSize( value, value )

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].class:SetStretchMode( 1 )
                                        Group.Party[ i ].class:SetSize( value, value )
                                    end
                                end

                                function ui:Reset()
                                    self:SetValue( Group.Default_Settings.class_icon_size )
                                end
                            end )
                        )

                        ui:AddFiller( 0, 16 )

                        ui:AddItem(
                            UI:Create( "DIVIDER", ui, function( ui )
                            end )
                        )
                    end

                    if k == "Leader" then
                        ui:AddFiller( 0, 16 )

                        ui:AddItem(
                            UI:Create( "TEXT", ui, function( ui )
                                ui:SetSize( 360, 16 )
                                ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                                ui:SetText( "Icon Size" )
                            end )
                        )

                        ui:AddFiller( 0, UI.Spacing )

                        --Leader Icon Size
                        ui:AddItem(
                            UI:Create( "SLIDER_RESET", ui, function( ui )
                                ui:SetWidth( 360 )
                                ui:SetRange( 4, 32 )
                                ui:SetValue( Group.Settings.leader_icon_size )
                                ui:SetKey( "" )
                                ui:SetKeySize( 0 )

                                function ui:ValueChanged( value )
                                    Group.Settings.leader_icon_size = value

                                    main.Frame.leader:SetStretchMode( 1 )
                                    main.Frame.leader:SetSize( value, value )

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].leader:SetStretchMode( 1 )
                                        Group.Party[ i ].leader:SetSize( value, value )
                                    end

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                end

                                function ui:SliderChanged( value )
                                    Group.Settings.leader_icon_size = value

                                    main.Frame.leader:SetStretchMode( 1 )
                                    main.Frame.leader:SetSize( value, value )

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].leader:SetStretchMode( 1 )
                                        Group.Party[ i ].leader:SetSize( value, value )
                                    end
                                end

                                function ui:Reset()
                                    self:SetValue( Group.Default_Settings.leader_icon_size )
                                end
                            end )
                        )

                        ui:AddFiller( 0, 16 )

                        ui:AddItem(
                            UI:Create( "DIVIDER", ui, function( ui )
                            end )
                        )
                    end

                    if k == "Morale_Text" then
                        ui:AddFiller( 0, 16 )

                        ui:AddItem(
                            UI:Create( "DIVIDER", ui, function( ui )
                            end )
                        )
                    end

                    if k == "Effect" then
                        ui:AddFiller( 0, 16 )

                        ui:AddItem(
                            UI:Create( "TEXT", ui, function( ui )
                                ui:SetSize( 360, 16 )
                                ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                                ui:SetText( "Effect Size" )
                            end )
                        )

                        ui:AddFiller( 0, UI.Spacing )

                        --Effect Size
                        ui:AddItem(
                            UI:Create( "SLIDER_RESET", ui, function( ui )
                                ui:SetWidth( 360 )
                                ui:SetRange( 8, 32 )
                                ui:SetValue( Group.Settings.effect_size )
                                ui:SetKey( "" )
                                ui:SetKeySize( 0 )

                                function ui:ValueChanged( value )
                                    Group.Settings.effect_size = value

                                    for i = 1, #main.Frame.effect do
                                        main.Frame.effect[ i ]:SetStretchMode( 1 )
                                        main.Frame.effect[ i ]:SetSize( value, value )
                                    end

                                    main.Frame:EffectLayout()

                                    for i = 1, #Group.Party do
                                        for k = 1, Group.Party[ i ].effect_count do
                                            Group.Party[ i ].effect[ k ]:SetStretchMode( 1 )
                                            Group.Party[ i ].effect[ k ]:SetSize( value, value )
                                            Group.Party[ i ]:EffectLayout()
                                        end
                                    end

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                end

                                function ui:SliderChanged( value )
                                    Group.Settings.effect_size = value

                                    for i = 1, #main.Frame.effect do
                                        main.Frame.effect[ i ]:SetStretchMode( 1 )
                                        main.Frame.effect[ i ]:SetSize( value, value )
                                    end

                                    main.Frame:EffectLayout()

                                    for i = 1, #Group.Party do
                                        for k = 1, Group.Party[ i ].effect_count do
                                            Group.Party[ i ].effect[ k ]:SetStretchMode( 1 )
                                            Group.Party[ i ].effect[ k ]:SetSize( value, value )
                                            Group.Party[ i ]:EffectLayout()
                                        end
                                    end
                                end

                                function ui:Reset()
                                    self:SetValue( Group.Default_Settings.effect_size )
                                end
                            end )
                        )

                        ui:AddFiller( 0, 16 )

                        ui:AddItem(
                            UI:Create( "TEXT", ui, function( ui )
                                ui:SetSize( 360, 16 )
                                ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                                ui:SetText( "Effect Spacing" )
                            end )
                        )

                        ui:AddFiller( 0, UI.Spacing )

                        --Effect Spacing
                        ui:AddItem(
                            UI:Create( "SLIDER_RESET", ui, function( ui )
                                ui:SetWidth( 360 )
                                ui:SetRange( 0, 16 )
                                ui:SetValue( Group.Settings.effect_spacing )
                                ui:SetKey( "" )
                                ui:SetKeySize( 0 )

                                function ui:ValueChanged( value )
                                    Group.Settings.effect_spacing = value

                                    main.Frame:EffectLayout()

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ]:EffectLayout()
                                    end

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                end

                                function ui:SliderChanged( value )
                                    Group.Settings.effect_spacing = value

                                    main.Frame:EffectLayout()

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ]:EffectLayout()
                                    end
                                end

                                function ui:Reset()
                                    self:SetValue( Group.Default_Settings.effect_spacing )
                                end
                            end )
                        )

                        ui:AddFiller( 0, 16 )

                        ui:AddItem(
                            UI:Create( "TEXT", ui, function( ui )
                                ui:SetSize( 360, 16 )
                                ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                                ui:SetText( "Max Effects Per Row" )
                            end )
                        )

                        ui:AddFiller( 0, UI.Spacing )

                        --Effects Per Row
                        ui:AddItem(
                            UI:Create( "SLIDER_RESET", ui, function( ui )
                                ui:SetWidth( 360 )
                                ui:SetRange( 1, 10 )
                                ui:SetValue( Group.Settings.effect_row_count )
                                ui:SetKey( "" )
                                ui:SetKeySize( 0 )

                                function ui:ValueChanged( value )
                                    Group.Settings.effect_row_count = value

                                    main.Frame:EffectLayout()

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ]:EffectLayout()
                                    end

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                end

                                function ui:SliderChanged( value )
                                    Group.Settings.effect_row_count = value

                                    main.Frame:EffectLayout()

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ]:EffectLayout()
                                    end
                                end

                                function ui:Reset()
                                    self:SetValue( Group.Default_Settings.effect_row_count )
                                end
                            end )
                        )

                        ui:AddFiller( 0, 16 )

                        ui:AddItem(
                            UI:Create( "DIVIDER", ui, function( ui )
                            end )
                        )
                    end
                end

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Special Effect Size" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Effect Size
                ui:AddItem(
                    UI:Create( "SLIDER_RESET", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetRange( 8, 32 )
                        ui:SetValue( Group.Settings.special_effect_size )
                        ui:SetKey( "" )
                        ui:SetKeySize( 0 )

                        function ui:ValueChanged( value )
                            Group.Settings.special_effect_size = value

                            main.Frame.special:SetSize( value, value )
                            main.Frame.special:PositionChanged()

                            for i = 1, #Group.Party do
                                Group.Party[ i ].special:SetStretchMode( 1 )
                                Group.Party[ i ].special:SetSize( value, value )
                                Group.Party[ i ].special:PositionChanged()
                            end

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                        end

                        function ui:SliderChanged( value )
                            Group.Settings.special_effect_size = value

                            main.Frame.special:SetSize( value, value )
                            main.Frame.special:PositionChanged()

                            for i = 1, #Group.Party do
                                Group.Party[ i ].special:SetStretchMode( 1 )
                                Group.Party[ i ].special:SetSize( value, value )
                                Group.Party[ i ].special:PositionChanged()
                            end
                        end

                        function ui:Reset()
                            self:SetValue( Group.Default_Settings.special_effect_size )
                        end
                    end )
                )

                ui:SetHeightToChildren( 16 )
            end )
        )

        --Frame Misc
        main.leftBar:AddItem(
            UI:Create( "LIST", main.leftBar, function( ui )
                ui:SetWidth( 360 )
                ui:SetColor( 0, 200, 0, 0 )
                ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                ui:AddItem(
                    UI:Create( "HEADER", ui, function( ui )
                        ui:SetText( "Frame Misc" )
                    end )
                )

                ui:AddFiller( 0, 16 )

                --Enable Class Icon
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Enable Class Icon" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.enable_class_icon )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()

                                Group.Settings.enable_class_icon = checked

                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                                for i = 1, #Group.Party do
                                    Group.Party[ i ].class:SetVisible( checked )
                                end

                                main.Frame.class:SetVisible( checked )
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Enable Leader Icon
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Enable Leader Icon" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.enable_leader_icon )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()

                                Group.Settings.enable_leader_icon = checked

                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                                if Group.Leader then
                                    Group.Party[ Group.PartyName[ Group.Leader ] ]:SetLeader( checked )
                                end

                                main.Frame.leader:SetVisible( checked )
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, 16 )

                --Enable Player Name
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Enable Name Text" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.enable_player_name )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()

                                Group.Settings.enable_player_name = checked

                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                                for i = 1, #Group.Party do
                                    Group.Party[ i ].name:SetVisible( checked )
                                end

                                main.Frame.name:SetVisible( checked )
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Enable Morale Text
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Enable Morale Text" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.enable_morale_text )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()

                                Group.Settings.enable_morale_text = checked

                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                                for i = 1, #Group.Party do
                                    Group.Party[ i ].morale.text:SetVisible( checked )
                                    Group.Party[ i ]:Init()
                                end

                                main.Frame.morale.text:SetVisible( checked )
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, 16 )

                --Track Crowd Control Effects
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Track CC Effects ( Self Only )" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.track_crowd_control )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()

                                Group.Settings.track_crowd_control = checked

                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                                for i = 1, #Group.Party do
                                    if Group.Party[ i ].localplayer then
                                        Group.Party[ i ]:RefreshEffects( Group.Party[ i ].player_effects, true )
                                    end
                                end
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Track Debuff Effects
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Track Debuff Effects ( Self Only )" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.track_debuff )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()

                                Group.Settings.track_debuff = checked

                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                                for i = 1, #Group.Party do
                                    if Group.Party[ i ].localplayer then
                                        Group.Party[ i ]:RefreshEffects( Group.Party[ i ].player_effects, true )
                                    end
                                end
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Track Curable Effects
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Track Curable Effects ( Self Only )" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.track_curable )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()

                                Group.Settings.track_curable = checked

                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                                for i = 1, #Group.Party do
                                    if Group.Party[ i ].localplayer then
                                        Group.Party[ i ]:RefreshEffects( Group.Party[ i ].player_effects, true )
                                    end
                                end
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, 16 )

                --Enable Effect Duration
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Enable Effect Duration" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.enable_effect_duration )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()

                                Group.Settings.enable_effect_duration = checked

                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                                for i = 1, #main.Frame.effect do
                                    main.Frame.effect[ i ].text:SetVisible( checked )
                                end

                                for i = 1, #Group.Party do
                                    for k = 1, #Group.Party[ i ].effect do
                                        if not Group.Party[ i ].effect[ k ].static then
                                            Group.Party[ i ].effect[ k ].text:SetVisible( checked )
                                        end
                                    end
                                end
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Effect Flash Threshold" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Effect Flash Threshold
                ui:AddItem(
                    UI:Create( "SLIDER_RESET", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetKey( "" )
                        ui:SetRange( 0, 60 )
                        ui:SetValue( Group.Settings.effect_flash_threshold )
                        ui:SetKeySize( 0)

                        function ui:ValueChanged( value )
                            Group.Settings.effect_flash_threshold = value

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                        end
        
                        function ui:SliderChanged( value )
                            Group.Settings.effect_flash_threshold = value
                        end

                        function ui:Reset()
                            self:SetValue( Group.Default_Settings.effect_flash_threshold )
                        end
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Effect Duration Threshold" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Effect Duration Threshold
                ui:AddItem(
                    UI:Create( "SLIDER_RESET", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetKey( "" )
                        ui:SetRange( 0, 600 )
                        ui:SetValue( Group.Settings.effect_duration_threshold )
                        ui:SetKeySize( 0 )

                        function ui:ValueChanged( value )
                            Group.Settings.effect_duration_threshold = value

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                        end
        
                        function ui:SliderChanged( value )
                            Group.Settings.effect_duration_threshold = value
                        end

                        function ui:Reset()
                            self:SetValue( Group.Default_Settings.effect_duration_threshold )
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                --Enable Special Effect
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Enable Special Effect" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.enable_special_effect )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()

                                Group.Settings.enable_special_effect = checked

                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                                main.Frame.special:SetVisible( checked )

                                if checked then
                                    main.Frame.special_text:SetVisible( Group.Settings.enable_special_effect_duration )
                                else
                                    main.Frame.special_text:SetVisible( false )
                                end

                                for i = 1, #Group.Party do
                                    if Group.Party[ i ].special.active then
                                        Group.Party[ i ].special:SetVisible( checked )
                                        Group.Party[ i ].special_text:SetVisible( Group.Settings.enable_special_effect_duration )
                                    end
                                end
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Enable Special Effect Duration
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Enable Special Effect Duration" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.enable_special_effect_duration )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()

                                Group.Settings.enable_special_effect_duration = checked

                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                                main.Frame.special_text:SetVisible( checked )

                                for i = 1, #Group.Party do
                                    if Group.Party[ i ].special.active then
                                        Group.Party[ i ].special_text:SetVisible( checked )
                                    end
                                end
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, 16 )

                --Enable Unique Player Name Color
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Enable Unique Player Name Color" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.enable_unique_player_name_color )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()
        
                                Group.Settings.enable_unique_player_name_color = checked

                                if checked then
                                    main.Frame.name:SetForeColor( Group.Settings.Color.Unique_Name )
                                    main.Frame.name:SetOutlineColor( Group.Settings.Color.Unique_Name_Outline )
                                else
                                    main.Frame.name:SetForeColor( Group.Settings.Color.Name )
                                    main.Frame.name:SetOutlineColor( Group.Settings.Color.Name_Outline )
                                end

                                if checked then
                                    for i = 1, #Group.Party do
                                        if Group.Party[ i ].localplayer then
                                            Group.Party[ i ].name:SetForeColor( Group.Settings.Color.Unique_Name )
                                            Group.Party[ i ].name:SetOutlineColor( Group.Settings.Color.Unique_Name_Outline )

                                            break
                                        end
                                    end
                                else
                                    for i = 1, #Group.Party do
                                        if Group.Party[ i ].localplayer then
                                            Group.Party[ i ].name:SetForeColor( Group.Settings.Color.Name )
                                            Group.Party[ i ].name:SetOutlineColor( Group.Settings.Color.Name_Outline )

                                            break
                                        end
                                    end
                                end
        
                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, 16 )

                --Enable Unique Class Morale Color
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Enable Unique Class Morale Color" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.enable_unique_class_morale_color )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()
        
                                Group.Settings.enable_unique_class_morale_color = checked

                                if checked and not Group.Settings.enable_unique_player_morale_color then
                                    main.Frame.morale:SetColor( Group.Settings.Color.Class[ Player:GetClass() ] )
                                else
                                    if Group.Settings.enable_unique_player_morale_color then
                                        main.Frame.morale:SetColor( Group.Settings.Color.Unique_Morale )
                                    else
                                        main.Frame.morale:SetColor( Group.Settings.Color.Morale )
                                    end
                                end
        
                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Enable Unique Player Morale Color
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Enable Unique Player Morale Color" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.enable_unique_player_morale_color )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()
        
                                Group.Settings.enable_unique_player_morale_color = checked

                                if checked then
                                    main.Frame.morale:SetColor( Group.Settings.Color.Unique_Morale )
                                else
                                    if Group.Settings.enable_unique_class_morale_color then
                                        main.Frame.morale:SetColor( Group.Settings.Color.Class[ Player:GetClass() ] )
                                    else
                                        main.Frame.morale:SetColor( Group.Settings.Color.Morale )
                                    end
                                end

                                if checked then
                                    main.select_unique_name:SetLayerColor( Group.Default_Settings.Color.Unique_Morale )
                                    main.select_name:SetLayerColor( Group.Default_Settings.Color.Unique_Morale )
                                    main.select_special_effect:SetLayerColor( Group.Default_Settings.Color.Unique_Morale )
                                    main.select_unique_morale_text:SetLayerColor( Group.Default_Settings.Color.Unique_Morale )
                                else
                                    main.select_unique_name:SetLayerColor( Group.Default_Settings.Color.Morale )
                                    main.select_name:SetLayerColor( Group.Default_Settings.Color.Morale )
                                    main.select_special_effect:SetLayerColor( Group.Default_Settings.Color.Morale )
                                    main.select_unique_morale_text:SetLayerColor( Group.Default_Settings.Color.Morale )
                                end
        
                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, 16 )

                --Morale Threshold
                ui:AddItem(
                    UI:Create( "SLIDER_RESET", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetKey( "Morale Threshold" )
                        ui:SetRange( 0, 100 )
                        ui:SetValue( 100 * Group.Settings.morale_threshold )
                        ui:SetKeySize( 128 + 21 )

                        function ui:ValueChanged( value )
                            Group.Settings.morale_threshold = value / 100

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                        end
        
                        function ui:SliderChanged( value )
                            Group.Settings.morale_threshold = value / 100
                        end

                        function ui:Reset()
                            self:SetValue( 100 * Group.Default_Settings.morale_threshold )
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Morale Text Format" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Morale Text Format
                ui:AddItem(
                    UI:Create( "DROPDOWN", ui, function( ui )
                        ui:SetWidth( 360 )

                        local tbl = {
                            "%",
                            "Current",
                            "Current + %",
                            "Current / Max",
                            "Current / Max + %",
                        }

                        for i = 1, #tbl do
                            local item = ui:Add( tbl[ i ], function()
                                Group.Settings.morale_text_format = i

                                main.Frame.morale.text.format[ i ]()

                                for i = 1, #Group.Party do
                                    Group.Party[ i ]:Init()
                                end
            
                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            end )

                            if i == Group.Settings.morale_text_format then
                                ui:SetSelected( item )
                            end
                        end
                    end )
                )

                ui:SetHeightToChildren( 16 )
            end )
        )

        --Misc
        main.leftBar:AddItem(
            UI:Create( "LIST", main.leftBar, function( ui )
                ui:SetWidth( 360 )
                ui:SetColor( 0, 200, 0, 0 )
                ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                ui:AddItem(
                    UI:Create( "HEADER", ui, function( ui )
                        ui:SetText( "Misc" )
                    end )
                )

                ui:AddFiller( 0, 16 )

                --Disable Vanilla Party Vitals
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Disable Vanilla Party Vitals" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.disable_vanilla_party_ui )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()
                                
                                Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Party, not checked )
        
                                Group.Settings.disable_vanilla_party_ui = checked
        
                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                            end
                        end )
                    end )
                )

                --[[ ui:AddFiller( 0, UI.Spacing )

                --Disable Vanilla Player Vitals
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Disable Vanilla Player Vitals" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.disable_vanilla_player_ui )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()
                                
                                Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, not checked )
        
                                Group.Settings.disable_vanilla_player_ui = checked
        
                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Disable Vanilla Target Vitals
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Disable Vanilla Target Vitals" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.disable_vanilla_target_ui )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()
                                
                                Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Target, not checked )
        
                                Group.Settings.disable_vanilla_target_ui = checked
        
                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                            end
                        end )
                    end )
                ) ]]

                ui:AddFiller( 0, 16 )

                --Hide Group Frames When Not In Combat
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Hide Group Frames When Not In Combat" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.hide_out_of_combat )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()

                                Group.Settings.hide_out_of_combat = checked
                                
                                if not Group.hidden then
                                    if checked then
                                        PartyVitals:SetVisible( Player:IsInCombat() )
                                    else
                                        PartyVitals:SetVisible( true )
                                    end
                                end

                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Show Player Frame When Not In A Group
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Show Player Frame When Not In A Group" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.show_vitals_out_of_group )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()

                                Group.Settings.show_vitals_out_of_group = checked

                                if checked and Group.PartyCount == 0 then
                                    Group:Create( true )
                                elseif not checked and Group.PartyCount == 1 then
                                    Group:Remove()
                                end

                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Effect  Count ( Preview )" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Effect Count ( Preview )
                ui:AddItem(
                    UI:Create( "SLIDER", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetRange( 0, 20 )
                        ui:SetValue( 4 )
                        ui:SetKey( "" )
                        ui:SetKeySize( 0 )
                        ui:SetValueAlignment( 6 )

                        main.effect_count = 4

                        function ui:ValueChanged( value )
                            main.effect_count = value

                            for i = 1, 20 do
                                if i > value then
                                    main.Frame.effect[ i ]:SetVisible( false )
                                else
                                    main.Frame.effect[ i ]:SetVisible( true )
                                end
                            end

                            main.Frame:EffectLayout()
                        end

                        function ui:SliderChanged( value )
                            main.effect_count = value

                            for i = 1, 20 do
                                if i > value then
                                    main.Frame.effect[ i ]:SetVisible( false )
                                else
                                    main.Frame.effect[ i ]:SetVisible( true )
                                end
                            end

                            main.Frame:EffectLayout()
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                --Enable Layout Preview
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Enable Layout Preview" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.disable_vanilla_target_ui )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()

                                main.enable_layout_preview = checked

                                if checked then
                                    PartyVitals:DefinePreviewLayout( PartyVitals.preview_count )
                                    PartyVitals:RefreshPreview()
                                end
                                
                                for i = 1, 24 do
                                    if checked then
                                        if i <= PartyVitals.preview_count then
                                            PartyVitals.preview[ i ]:SetVisible( true )
                                        end
                                    else
                                        PartyVitals.preview[ i ]:SetVisible( false )
                                    end
                                end
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Layout Player Count ( Preview )" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Layout Player Count ( Preview )
                ui:AddItem(
                    UI:Create( "SLIDER", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetRange( 1, 24 )
                        ui:SetValue( 12 )
                        ui:SetValueAlignment( 6 )
                        ui:SetKey( "" )
                        ui:SetKeySize( 0 )

                        function ui:ValueChanged( value )
                            PartyVitals.preview_count = value

                            if main.enable_layout_preview then
                                for i = 1, 24 do
                                    if i <= PartyVitals.preview_count then
                                        PartyVitals.preview[ i ]:SetVisible( true )
                                    else
                                        PartyVitals.preview[ i ]:SetVisible( false )
                                    end
                                end
                            end

                            if main.enable_layout_preview then
                                PartyVitals:DefinePreviewLayout( value )
                                PartyVitals:RefreshPreview()
                            end
                        end

                        function ui:SliderChanged( value )
                            PartyVitals.preview_count = value

                            if main.enable_layout_preview then
                                for i = 1, 24 do
                                    if i <= PartyVitals.preview_count then
                                        PartyVitals.preview[ i ]:SetVisible( true )
                                    else
                                        PartyVitals.preview[ i ]:SetVisible( false )
                                    end
                                end
                            end

                            if main.enable_layout_preview then
                                PartyVitals:DefinePreviewLayout( value )
                                PartyVitals:RefreshPreview()
                            end
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                --Enable Toggle Button
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 16 )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                            ui:SetText( "Enable Toggle Button" )
                        end )

                        UI:Create( "CHECKBOX", ui, function( ui )
                            ui:SetSize( 16, 16 )
                            ui:SetPos( 360 - 16, 0 )
                            ui:SetChecked( Group.Settings.toggle )

                            function ui:CheckedChanged()
                                local checked = self:IsChecked()

                                Group.Settings.toggle = checked

                                Group.Toggle:SetVisible( checked )

                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 14 * 2 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 )
                        ui:SetText( "Note: Hiding the UI with this button will supersede the visibility status of the combat state toggle." )
                        ui:SetForeColor( Color( 125, 125, 125 ) )
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Toggle Button Position" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Toggle Button X
                ui:AddItem(
                    UI:Create( "SLIDER", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetRange( 0, UI.SCREEN_W - 32 )
                        ui:SetValue( Group.Settings.toggle_x )
                        ui:SetValueAlignment( 6 )
                        ui:SetValueSize( 32 )
                        ui:SetKey( "X" )

                        function ui:ValueChanged( value )
                            Group.Settings.toggle_x = value

                            Group.Toggle:SetPos( value, Group.Settings.toggle_y )

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                        end

                        function ui:SliderChanged( value )
                            Group.Settings.toggle_x = value

                            Group.Toggle:SetPos( value, Group.Settings.toggle_y )
                        end
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Toggle Button Y
                ui:AddItem(
                    UI:Create( "SLIDER", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetRange( 0, UI.SCREEN_H - 32 )
                        ui:SetValue( Group.Settings.toggle_y )
                        ui:SetValueAlignment( 6 )
                        ui:SetValueSize( 32 )
                        ui:SetKey( "Y" )

                        function ui:ValueChanged( value )
                            Group.Settings.toggle_y = value

                            Group.Toggle:SetPos( Group.Settings.toggle_x, value )

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                        end

                        function ui:SliderChanged( value )
                            Group.Settings.toggle_y = value

                            Group.Toggle:SetPos( Group.Settings.toggle_x, value )
                        end
                    end )
                )

                ui:SetHeightToChildren( 16 )
            end )
        )
        -----------------------------------------------------

        --Frame Color
        main.rightBar:AddItem(
            UI:Create( "LIST", main.rightBar, function( ui )
                ui:SetWidth( 360 )
                ui:SetColor( 200, 0, 0, 0 )
                ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                ui:AddItem(
                    UI:Create( "HEADER", ui, function( ui )
                        ui:SetText( "Frame Color" )
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Morale" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Morale
                ui:AddItem(
                    UI:Create( "COLOR_SELECT", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetInternalColor( Group.Settings.Color.Morale )
                        ui:SetDefaultColor( Group.Default_Settings.Color.Morale )
                        ui:SetBackgroundColor( Group.Settings.Color.Background )

                        main.select_morale = ui

                        function ui:ColorChanged( color )
                            Group.Settings.Color.Morale = color

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            if not Group.Settings.enable_unique_player_morale_color then
                                main.Frame.morale:SetColor( color )
                            end

                            main.select_name:SetLayerColor( color )

                            if not Group.Settings.enable_unique_player_morale_color then
                                main.select_unique_name:SetLayerColor( color )
                                main.select_name:SetLayerColor( color )
                                main.select_special_effect:SetLayerColor( color )
                                main.select_unique_morale_text:SetLayerColor( color )
                            end
                        end

                        function ui:ColorSliderChanged( color )
                            Group.Settings.Color.Morale = color

                            if not Group.Settings.enable_unique_player_morale_color then
                                main.Frame.morale:SetColor( color )
                            end

                            main.select_name:SetLayerColor( color )

                            if not Group.Settings.enable_unique_player_morale_color then
                                main.select_unique_name:SetLayerColor( color )
                                main.select_name:SetLayerColor( color )
                                main.select_special_effect:SetLayerColor( color )
                                main.select_unique_morale_text:SetLayerColor( color )
                            end
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Power" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Power
                ui:AddItem(
                    UI:Create( "COLOR_SELECT", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetInternalColor( Group.Settings.Color.Power )
                        ui:SetDefaultColor( Group.Default_Settings.Color.Power )
                        ui:SetBackgroundColor( Group.Settings.Color.Background )

                        main.select_power = ui

                        function ui:ColorChanged( color )
                            Group.Settings.Color.Power = color

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            main.Frame.power:SetColor( color )

                            for i = 1, #Group.Party do
                                Group.Party[ i ].power:SetColor( color )
                            end
                        end

                        function ui:ColorSliderChanged( color )
                            Group.Settings.Color.Power = color

                            main.Frame.power:SetColor( color )

                            for i = 1, #Group.Party do
                                Group.Party[ i ].power:SetColor( color )
                            end
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Bubble" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Bubble
                ui:AddItem(
                    UI:Create( "COLOR_SELECT", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetInternalColor( Group.Settings.Color.Bubble )
                        ui:SetDefaultColor( Group.Default_Settings.Color.Bubble )
                        ui:SetBackgroundColor( Group.Settings.Color.Background )

                        main.select_bubble = ui

                        function ui:ColorChanged( color )
                            Group.Settings.Color.Bubble = color

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            for i = 1, #Group.Party do
                                Group.Party[ i ].bubble:SetColor( color )
                            end
                        end

                        function ui:ColorSliderChanged( color )
                            Group.Settings.Color.Bubble = color

                            for i = 1, #Group.Party do
                                Group.Party[ i ].bubble:SetColor( color )
                            end
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Dead" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Dead
                ui:AddItem(
                    UI:Create( "COLOR_SELECT", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetInternalColor( Group.Settings.Color.Dead )
                        ui:SetDefaultColor( Group.Default_Settings.Color.Dead )
                        ui:SetBackgroundColor( Group.Settings.Color.Background )

                        main.select_dead = ui

                        function ui:ColorChanged( color )
                            Group.Settings.Color.Dead = color

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            for i = 1, #Group.Party do
                                Group.Party[ i ].dead:SetColor( color )
                            end
                        end

                        function ui:ColorSliderChanged( color )
                            Group.Settings.Color.Dead = color

                            for i = 1, #Group.Party do
                                Group.Party[ i ].dead:SetColor( color )
                            end
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Background" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Background
                ui:AddItem(
                    UI:Create( "COLOR_SELECT", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetInternalColor( Group.Settings.Color.Background )
                        ui:SetDefaultColor( Group.Default_Settings.Color.Background )
                        ui:SetBackgroundColor( 0, 0, 0, 0 )

                        function ui:ColorChanged( color )
                            Group.Settings.Color.Background = color

                            main.Frame:SetColor( color )

                            main.select_morale:SetBackgroundColor( color )
                            main.select_power:SetBackgroundColor( color )
                            main.select_bubble:SetBackgroundColor( color )
                            main.select_dead:SetBackgroundColor( color )
                            main.select_threshold:SetBackgroundColor( color )
                            main.select_select:SetBackgroundColor( color )
                            main.select_hover:SetBackgroundColor( color )
                            main.select_name:SetBackgroundColor( color )
                            main.select_unique_name:SetBackgroundColor( color )
                            main.select_unique_morale:SetBackgroundColor( color )
                            main.select_unique_morale_text:SetBackgroundColor( color )
                            main.select_special_effect:SetBackgroundColor( color )

                            main.select_unique_class_morale:SetBackgroundColor( color )

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            for i = 1, #Group.Party do
                                Group.Party[ i ]:SetColor( color )
                            end
                        end

                        function ui:ColorSliderChanged( color )
                            Group.Settings.Color.Background = color

                            main.Frame:SetColor( color )

                            main.select_morale:SetBackgroundColor( color )
                            main.select_power:SetBackgroundColor( color )
                            main.select_bubble:SetBackgroundColor( color )
                            main.select_dead:SetBackgroundColor( color )
                            main.select_threshold:SetBackgroundColor( color )
                            main.select_select:SetBackgroundColor( color )
                            main.select_hover:SetBackgroundColor( color )
                            main.select_name:SetBackgroundColor( color )
                            main.select_unique_name:SetBackgroundColor( color )
                            main.select_unique_morale:SetBackgroundColor( color )
                            main.select_unique_morale_text:SetBackgroundColor( color )
                            main.select_special_effect:SetBackgroundColor( color )

                            main.select_unique_class_morale:SetBackgroundColor( color )

                            for i = 1, #Group.Party do
                                Group.Party[ i ]:SetColor( color )
                            end
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Threshold" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Threshold
                ui:AddItem(
                    UI:Create( "COLOR_SELECT", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetInternalColor( Group.Settings.Color.Threshold )
                        ui:SetDefaultColor( Group.Default_Settings.Color.Threshold )
                        ui:SetBackgroundColor( Group.Settings.Color.Background )

                        main.select_threshold = ui

                        function ui:ColorChanged( color )
                            Group.Settings.Color.Threshold = color

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                        end

                        function ui:ColorSliderChanged( color )
                            Group.Settings.Color.Threshold = color
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Select" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Select
                ui:AddItem(
                    UI:Create( "COLOR_SELECT", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetInternalColor( Group.Settings.Color.Select )
                        ui:SetDefaultColor( Group.Default_Settings.Color.Select )
                        ui:SetBackgroundColor( Group.Settings.Color.Background )

                        main.select_select = ui

                        function ui:ColorChanged( color )
                            Group.Settings.Color.Select = color

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            for i = 1, #Group.Party do
                                for k = 1, 4 do
                                    Group.Party[ i ].selection:SetBorderColor( color )
                                end
                            end
                        end

                        function ui:ColorSliderChanged( color )
                            Group.Settings.Color.Select = color

                            for i = 1, #Group.Party do
                                for k = 1, 4 do
                                    Group.Party[ i ].selection:SetBorderColor( color )
                                end
                            end
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Hover" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Hover
                ui:AddItem(
                    UI:Create( "COLOR_SELECT", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetInternalColor( Group.Settings.Color.Hover )
                        ui:SetDefaultColor( Group.Default_Settings.Color.Hover )
                        ui:SetBackgroundColor( Group.Settings.Color.Background )

                        main.select_hover = ui

                        function ui:ColorChanged( color )
                            Group.Settings.Color.Hover = color

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                        end

                        function ui:ColorSliderChanged( color )
                            Group.Settings.Color.Hover = color
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Unique Morale" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Unique Morale
                ui:AddItem(
                    UI:Create( "COLOR_SELECT", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetInternalColor( Group.Settings.Color.Unique_Morale )
                        ui:SetDefaultColor( Group.Default_Settings.Color.Unique_Morale )
                        ui:SetBackgroundColor( Group.Settings.Color.Background )

                        main.select_unique_morale = ui

                        function ui:ColorChanged( color )
                            Group.Settings.Color.Unique_Morale = color

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            if Group.Settings.enable_unique_player_morale_color then
                                main.Frame.morale:SetColor( color )
                            end

                            if Group.Settings.enable_unique_player_morale_color then
                                main.select_unique_name:SetLayerColor( color )
                                main.select_name:SetLayerColor( color )
                                main.select_special_effect:SetLayerColor( color )
                                main.select_unique_morale_text:SetLayerColor( color )
                            end
                        end

                        function ui:ColorSliderChanged( color )
                            Group.Settings.Color.Unique_Morale = color

                            if Group.Settings.enable_unique_player_morale_color then
                                main.Frame.morale:SetColor( color )
                            end

                            if Group.Settings.enable_unique_player_morale_color then
                                main.select_unique_name:SetLayerColor( color )
                                main.select_name:SetLayerColor( color )
                                main.select_special_effect:SetLayerColor( color )
                                main.select_unique_morale_text:SetLayerColor( color )
                            end
                        end
                    end )
                )

                ui:SetHeightToChildren( 16 )
            end )
        )

        --Font
        main.rightBar:AddItem(
            UI:Create( "LIST", main.rightBar, function( ui )
                ui:SetWidth( 360 )
                ui:SetColor( 200, 0, 200, 0 )
                ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                ui:AddItem(
                    UI:Create( "HEADER", ui, function( ui )
                        ui:SetText( "Font" )
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Name" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Player Name
                ui:AddItem(
                    UI:Create( "LIST", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetColor( 0, 0, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        ui:AddItem(
                            UI:Create( "SLIDER", ui, function( ui )
                                ui:SetWidth( 360 )
                                ui:SetRange( 1, #Group.Font )
                                ui:SetValueAlignment( 6 )
                                ui:SetValue( Group.Settings.player_font_type, true )
                                ui:SetKey( "Type" )
                                ui:SetKeySize( 32 )
                                ui:SetValueSize( 144 )
                                ui:SetText( Group.Font[ Group.Settings.player_font_type ].name )

                                main.slider_player_name_type = ui
                
                                function ui:ValueChanged( value )
                                    Group.Settings.player_font_type = value
                                    Group.Settings.player_font_size = 1
                
                                    self:SetText( Group.Font[ value ].name )
                
                                    main.slider_player_name_size:SetRange( 1, #Group.Font[ value ].size )
                                    main.slider_player_name_size:SetValue( 1, true )
                                    main.slider_player_name_size:SetText( Group.Font[ Group.Settings.player_font_type ].size[ Group.Settings.player_font_size ] )

                                    main.Frame.name:SetHeight( Group.Font[ Group.Settings.player_font_type ].size[ Group.Settings.player_font_size ] )
                                    main.Frame.name:SetFont( Group:GetFont( Group.Settings.player_font_type, Group.Settings.player_font_size ) )
                                    main.Frame.name:SetText( main.Frame.name:GetText() )

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].name:SetHeight( Group.Font[ Group.Settings.player_font_type ].size[ Group.Settings.player_font_size ] )
                                        Group.Party[ i ].name:SetFont( Group:GetFont( Group.Settings.player_font_type, Group.Settings.player_font_size ) )
                                        Group.Party[ i ].name:SetText( Group.Party[ i ].player_name )
                                    end
                
                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                end
                
                                function ui:SliderChanged( value )
                                    Group.Settings.player_font_type = value
                                    Group.Settings.player_font_size = 1
                
                                    self:SetText( Group.Font[ value ].name )
                
                                    main.slider_player_name_size:SetRange( 1, #Group.Font[ value ].size )
                                    main.slider_player_name_size:SetValue( 1, true )
                                    main.slider_player_name_size:SetText( Group.Font[ Group.Settings.player_font_type ].size[ Group.Settings.player_font_size ] )

                                    main.Frame.name:SetHeight( Group.Font[ Group.Settings.player_font_type ].size[ Group.Settings.player_font_size ] )
                                    main.Frame.name:SetFont( Group:GetFont( Group.Settings.player_font_type, Group.Settings.player_font_size ) )
                                    main.Frame.name:SetText( main.Frame.name:GetText() )

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].name:SetHeight( Group.Font[ Group.Settings.player_font_type ].size[ Group.Settings.player_font_size ] )
                                        Group.Party[ i ].name:SetFont( Group:GetFont( Group.Settings.player_font_type, Group.Settings.player_font_size ) )
                                        Group.Party[ i ].name:SetText( Group.Party[ i ].player_name )
                                    end
                                end
                            end )
                        )

                        ui:AddFiller( 0, UI.Spacing )

                        ui:AddItem(
                            UI:Create( "SLIDER_RESET", ui, function( ui )
                                ui:SetWidth( 360 )
                                ui:SetRange( 1, #Group.Font[ Group.Settings.player_font_type ].size )
                                ui:SetValue( Group.Settings.player_font_size, true )
                                ui:SetKey( "Size" )
                                ui:SetKeySize( 32 )
                                ui:SetText( Group.Font[ Group.Settings.player_font_type ].size[ Group.Settings.player_font_size ] )

                                main.slider_player_name_size = ui
                
                                function ui:ValueChanged( value )
                                    Group.Settings.player_font_size = value
                
                                    self:SetText( Group.Font[ Group.Settings.player_font_type ].size[ Group.Settings.player_font_size ] )
                
                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                                    main.Frame.name:SetHeight( Group.Font[ Group.Settings.player_font_type ].size[ Group.Settings.player_font_size ] )
                                    main.Frame.name:SetFont( Group:GetFont( Group.Settings.player_font_type, Group.Settings.player_font_size ) )
                                    main.Frame.name:SetText( main.Frame.name:GetText() )

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].name:SetHeight( Group.Font[ Group.Settings.player_font_type ].size[ Group.Settings.player_font_size ] )
                                        Group.Party[ i ].name:SetFont( Group:GetFont( Group.Settings.player_font_type, Group.Settings.player_font_size ) )
                                        Group.Party[ i ].name:SetText( Group.Party[ i ].player_name )
                                    end
                                end
                
                                function ui:SliderChanged( value )
                                    Group.Settings.player_font_size = value
                
                                    self:SetText( Group.Font[ Group.Settings.player_font_type ].size[ Group.Settings.player_font_size ] )

                                    main.Frame.name:SetHeight( Group.Font[ Group.Settings.player_font_type ].size[ Group.Settings.player_font_size ] )
                                    main.Frame.name:SetFont( Group:GetFont( Group.Settings.player_font_type, Group.Settings.player_font_size ) )
                                    main.Frame.name:SetText( main.Frame.name:GetText() )

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].name:SetHeight( Group.Font[ Group.Settings.player_font_type ].size[ Group.Settings.player_font_size ] )
                                        Group.Party[ i ].name:SetFont( Group:GetFont( Group.Settings.player_font_type, Group.Settings.player_font_size ) )
                                        Group.Party[ i ].name:SetText( Group.Party[ i ].player_name )
                                    end
                                end

                                function ui:Reset()
                                    Group.Settings.player_font_type = Group.Default_Settings.player_font_type
                                    Group.Settings.player_font_size = Group.Default_Settings.player_font_size

                                    main.slider_player_name_type:SetValue( Group.Default_Settings.player_font_type, true )
                                    main.slider_player_name_type:SetText( Group.Font[ Group.Default_Settings.player_font_type ].name )

                                    self:SetRange( 1, #Group.Font[ Group.Default_Settings.player_font_type ].size )
                                    self:SetValue( Group.Default_Settings.player_font_size, true )
                                    self:SetText( Group.Font[ Group.Default_Settings.player_font_type ].size[ Group.Default_Settings.player_font_size ] )

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                                    main.Frame.name:SetHeight( Group.Font[ Group.Settings.player_font_type ].size[ Group.Settings.player_font_size ] )
                                    main.Frame.name:SetFont( Group:GetFont( Group.Settings.player_font_type, Group.Settings.player_font_size ) )
                                    main.Frame.name:SetText( main.Frame.name:GetText() )

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].name:SetHeight( Group.Font[ Group.Settings.player_font_type ].size[ Group.Settings.player_font_size ] )
                                        Group.Party[ i ].name:SetFont( Group:GetFont( Group.Settings.player_font_type, Group.Settings.player_font_size ) )
                                        Group.Party[ i ].name:SetText( Group.Party[ i ].player_name )
                                    end

                                    main.player_name_outline:SetChecked( Group.Default_Settings.player_font_outline )
                                end
                            end )
                        )

                        ui:AddFiller( 0, UI.Spacing )

                        ui:AddItem(
                            UI:Create( "TEXT", ui, function( ui )
                                ui:SetSize( 360, 16 )
                                ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                                ui:SetText( "Outline" )

                                main.player_name_outline = UI:Create( "CHECKBOX", ui, function( ui )
                                    ui:SetSize( 16, 16 )
                                    ui:SetPos( 75, 0 )
                                    ui:SetChecked( Group.Settings.player_font_outline )
                    
                                    function ui:CheckedChanged()
                                        local checked = self:IsChecked()
                    
                                        Group.Settings.player_font_outline = checked
                    
                                        if checked then
                                            main.Frame.name:SetFontStyle( Turbine.UI.FontStyle.Outline )
                                        else
                                            main.Frame.name:SetFontStyle( Turbine.UI.FontStyle.None )
                                        end

                                        main.Frame.name:SetText( main.Frame.name:GetText() )
    
                                        for i = 1, #Group.Party do
                                            if checked then
                                                Group.Party[ i ].name:SetFontStyle( Turbine.UI.FontStyle.Outline )
                                                Group.Party[ i ].name:SetText( Group.Party[ i ].player_name )
                                            else
                                                Group.Party[ i ].name:SetFontStyle( Turbine.UI.FontStyle.None )
                                                Group.Party[ i ].name:SetText( Group.Party[ i ].player_name )
                                            end
                                        end
                    
                                        Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                    end
                                end )
                            end )
                        )

                        ui:SetHeightToChildren()
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Color" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Name
                ui:AddItem(
                    UI:Create( "COLOR_SELECT", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetInternalColor( Group.Settings.Color.Name )
                        ui:SetDefaultColor( Group.Default_Settings.Color.Name )
                        ui:SetBackgroundColor( Group.Settings.Color.Background )

                        if Group.Settings.enable_unique_player_morale_color then
                            ui:SetLayerColor( Group.Default_Settings.Color.Unique_Morale )
                        else
                            ui:SetLayerColor( Group.Default_Settings.Color.Morale )
                        end

                        ui:EnableLayer( true )

                        main.select_name = ui

                        function ui:ColorChanged( color )
                            Group.Settings.Color.Name = color

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            if not Group.Settings.enable_unique_player_name_color then
                                main.Frame.name:SetForeColor( color )
                            end

                            for i = 1, #Group.Party do
                                if not ( Group.Settings.enable_unique_player_name_color and Group.Party[ i ].localplayer ) then
                                    Group.Party[ i ].name:SetForeColor( color )

                                    break
                                end
                            end
                        end

                        function ui:ColorSliderChanged( color )
                            Group.Settings.Color.Name = color

                            if not Group.Settings.enable_unique_player_name_color then
                                main.Frame.name:SetForeColor( color )
                            end

                            for i = 1, #Group.Party do
                                if not ( Group.Settings.enable_unique_player_name_color and Group.Party[ i ].localplayer ) then
                                    Group.Party[ i ].name:SetForeColor( color )

                                    break
                                end
                            end
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Outline" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Name Outline
                ui:AddItem(
                    UI:Create( "COLOR_SELECT", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetInternalColor( Group.Settings.Color.Name_Outline )
                        ui:SetDefaultColor( Group.Default_Settings.Color.Name_Outline )
                        ui:SetBackgroundColor( 0, 0, 0, 0 )

                        function ui:ColorChanged( color )
                            Group.Settings.Color.Name_Outline = color

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            if not Group.Settings.enable_unique_player_name_color then
                                main.Frame.name:SetOutlineColor( color )
                            end

                            for i = 1, #Group.Party do
                                if not ( Group.Settings.enable_unique_player_name_color and Group.Party[ i ].localplayer ) then
                                    Group.Party[ i ].name:SetOutlineColor( color )

                                    break
                                end
                            end
                        end

                        function ui:ColorSliderChanged( color )
                            Group.Settings.Color.Name_Outline = color

                            if not Group.Settings.enable_unique_player_name_color then
                                main.Frame.name:SetOutlineColor( color )
                            end

                            for i = 1, #Group.Party do
                                if not ( Group.Settings.enable_unique_player_name_color and Group.Party[ i ].localplayer ) then
                                    Group.Party[ i ].name:SetOutlineColor( color )

                                    break
                                end
                            end
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Unique Color" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Unique Name
                ui:AddItem(
                    UI:Create( "COLOR_SELECT", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetInternalColor( Group.Settings.Color.Unique_Name )
                        ui:SetDefaultColor( Group.Default_Settings.Color.Unique_Name )
                        ui:SetBackgroundColor( Group.Settings.Color.Background )

                        if Group.Settings.enable_unique_player_morale_color then
                            ui:SetLayerColor( Group.Default_Settings.Color.Unique_Morale )
                        else
                            ui:SetLayerColor( Group.Default_Settings.Color.Morale )
                        end

                        ui:EnableLayer( true )

                        main.select_unique_name = ui

                        function ui:ColorChanged( color )
                            Group.Settings.Color.Unique_Name = color

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            if Group.Settings.enable_unique_player_name_color then
                                main.Frame.name:SetForeColor( color )
                            end

                            for i = 1, #Group.Party do
                                if Group.Settings.enable_unique_player_name_color and Group.Party[ i ].localplayer then
                                    Group.Party[ i ].name:SetForeColor( color )

                                    break
                                end
                            end
                        end

                        function ui:ColorSliderChanged( color )
                            Group.Settings.Color.Unique_Name = color

                            if Group.Settings.enable_unique_player_name_color then
                                main.Frame.name:SetForeColor( color )
                            end

                            for i = 1, #Group.Party do
                                if Group.Settings.enable_unique_player_name_color and Group.Party[ i ].localplayer then
                                    Group.Party[ i ].name:SetForeColor( color )

                                    break
                                end
                            end
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Unique Outline" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Unique Name Outline
                ui:AddItem(
                    UI:Create( "COLOR_SELECT", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetInternalColor( Group.Settings.Color.Unique_Name_Outline )
                        ui:SetDefaultColor( Group.Default_Settings.Color.Unique_Name_Outline )
                        ui:SetBackgroundColor( 0, 0, 0, 0 )

                        function ui:ColorChanged( color )
                            Group.Settings.Color.Unique_Name_Outline = color

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            if Group.Settings.enable_unique_player_name_color then
                                main.Frame.name:SetOutlineColor( color )
                            end

                            for i = 1, #Group.Party do
                                if Group.Settings.enable_unique_player_name_color and Group.Party[ i ].localplayer then
                                    Group.Party[ i ].name:SetOutlineColor( color )

                                    break
                                end
                            end
                        end

                        function ui:ColorSliderChanged( color )
                            Group.Settings.Color.Unique_Name_Outline = color

                            if Group.Settings.enable_unique_player_name_color then
                                main.Frame.name:SetOutlineColor( color )
                            end

                            for i = 1, #Group.Party do
                                if Group.Settings.enable_unique_player_name_color and Group.Party[ i ].localplayer then
                                    Group.Party[ i ].name:SetOutlineColor( color )

                                    break
                                end
                            end
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "DIVIDER", ui, function( ui )
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Morale Text" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Morale Text
                ui:AddItem(
                    UI:Create( "LIST", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetColor( 0, 0, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        ui:AddItem(
                            UI:Create( "SLIDER", ui, function( ui )
                                ui:SetWidth( 360 )
                                ui:SetRange( 1, #Group.Font )
                                ui:SetValueAlignment( 6 )
                                ui:SetValue( Group.Settings.morale_font_type, true )
                                ui:SetKey( "Type" )
                                ui:SetKeySize( 32 )
                                ui:SetValueSize( 144 )
                                ui:SetText( Group.Font[ Group.Settings.morale_font_type ].name )

                                main.slider_morale_text_type = ui

                                function ui:ValueChanged( value )
                                    Group.Settings.morale_font_type = value
                                    Group.Settings.morale_font_size = 1

                                    self:SetText( Group.Font[ value ].name )

                                    main.slider_morale_text_font_size:SetRange( 1, #Group.Font[ value ].size )
                                    main.slider_morale_text_font_size:SetValue( 1, true )
                                    main.slider_morale_text_font_size:SetText( Group.Font[ Group.Settings.morale_font_type ].size[ Group.Settings.morale_font_size ] )

                                    main.Frame.morale.text:SetHeight( Group.Font[ Group.Settings.morale_font_type ].size[ Group.Settings.morale_font_size ] )
                                    main.Frame.morale.text:SetFont( Group:GetFont( Group.Settings.morale_font_type, Group.Settings.morale_font_size ) )
                                    main.Frame.morale.text:SetText( main.Frame.morale.text:GetText() )

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].morale.text:SetHeight( Group.Font[ Group.Settings.morale_font_type ].size[ Group.Settings.morale_font_size ] )
                                        Group.Party[ i ].morale.text:SetFont( Group:GetFont( Group.Settings.morale_font_type, Group.Settings.morale_font_size ) )
                                        Group.Party[ i ].morale.text:SetText( Group.Party[ i ].morale.text:GetText() )
                                    end

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                end

                                function ui:SliderChanged( value )
                                    Group.Settings.morale_font_type = value
                                    Group.Settings.morale_font_size = 1

                                    self:SetText( Group.Font[ value ].name )

                                    main.slider_morale_text_font_size:SetRange( 1, #Group.Font[ value ].size )
                                    main.slider_morale_text_font_size:SetValue( 1, true )
                                    main.slider_morale_text_font_size:SetText( Group.Font[ Group.Settings.morale_font_type ].size[ Group.Settings.morale_font_size ] )

                                    main.Frame.morale.text:SetHeight( Group.Font[ Group.Settings.morale_font_type ].size[ Group.Settings.morale_font_size ] )
                                    main.Frame.morale.text:SetFont( Group:GetFont( Group.Settings.morale_font_type, Group.Settings.morale_font_size ) )
                                    main.Frame.morale.text:SetText( main.Frame.morale.text:GetText() )

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].morale.text:SetHeight( Group.Font[ Group.Settings.morale_font_type ].size[ Group.Settings.morale_font_size ] )
                                        Group.Party[ i ].morale.text:SetFont( Group:GetFont( Group.Settings.morale_font_type, Group.Settings.morale_font_size ) )
                                        Group.Party[ i ].morale.text:SetText( Group.Party[ i ].morale.text:GetText() )
                                    end
                                end
                            end )
                        )

                        ui:AddFiller( 0, UI.Spacing )

                        ui:AddItem(
                            UI:Create( "SLIDER_RESET", ui, function( ui )
                                ui:SetWidth( 360 )
                                ui:SetRange( 1, #Group.Font[ Group.Settings.morale_font_type ].size )
                                ui:SetValue( Group.Settings.morale_font_size, true )
                                ui:SetKey( "Size" )
                                ui:SetKeySize( 32 )
                                ui:SetText( Group.Font[ Group.Settings.morale_font_type ].size[ Group.Settings.morale_font_size ] )

                                main.slider_morale_text_font_size = ui

                                function ui:ValueChanged( value )
                                    Group.Settings.morale_font_size = value

                                    self:SetText( Group.Font[ Group.Settings.morale_font_type ].size[ Group.Settings.morale_font_size ] )

                                    main.Frame.morale.text:SetHeight( Group.Font[ Group.Settings.morale_font_type ].size[ Group.Settings.morale_font_size ] )
                                    main.Frame.morale.text:SetFont( Group:GetFont( Group.Settings.morale_font_type, Group.Settings.morale_font_size ) )
                                    main.Frame.morale.text:SetText( main.Frame.morale.text:GetText() )

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].morale.text:SetHeight( Group.Font[ Group.Settings.morale_font_type ].size[ Group.Settings.morale_font_size ] )
                                        Group.Party[ i ].morale.text:SetFont( Group:GetFont( Group.Settings.morale_font_type, Group.Settings.morale_font_size ) )
                                        Group.Party[ i ].morale.text:SetText( Group.Party[ i ].morale.text:GetText() )
                                    end

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                end

                                function ui:SliderChanged( value )
                                    Group.Settings.morale_font_size = value

                                    self:SetText( Group.Font[ Group.Settings.morale_font_type ].size[ Group.Settings.morale_font_size ] )

                                    main.Frame.morale.text:SetHeight( Group.Font[ Group.Settings.morale_font_type ].size[ Group.Settings.morale_font_size ] )
                                    main.Frame.morale.text:SetFont( Group:GetFont( Group.Settings.morale_font_type, Group.Settings.morale_font_size ) )
                                    main.Frame.morale.text:SetText( main.Frame.morale.text:GetText() )

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].morale.text:SetHeight( Group.Font[ Group.Settings.morale_font_type ].size[ Group.Settings.morale_font_size ] )
                                        Group.Party[ i ].morale.text:SetFont( Group:GetFont( Group.Settings.morale_font_type, Group.Settings.morale_font_size ) )
                                        Group.Party[ i ].morale.text:SetText( Group.Party[ i ].morale.text:GetText() )
                                    end
                                end

                                function ui:Reset()
                                    Group.Settings.morale_font_type = Group.Default_Settings.morale_font_type
                                    Group.Settings.morale_font_size = Group.Default_Settings.morale_font_size

                                    main.slider_morale_text_type:SetValue( Group.Default_Settings.morale_font_type, true )
                                    main.slider_morale_text_type:SetText( Group.Font[ Group.Default_Settings.morale_font_type ].name )

                                    self:SetRange( 1, #Group.Font[ Group.Default_Settings.morale_font_type ].size )
                                    self:SetValue( Group.Default_Settings.morale_font_size, true )
                                    self:SetText( Group.Font[ Group.Default_Settings.morale_font_type ].size[ Group.Default_Settings.morale_font_size ] )

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                                    main.Frame.morale.text:SetHeight( Group.Font[ Group.Settings.morale_font_type ].size[ Group.Settings.morale_font_size ] )
                                    main.Frame.morale.text:SetFont( Group:GetFont( Group.Settings.morale_font_type, Group.Settings.morale_font_size ) )
                                    main.Frame.morale.text:SetText( main.Frame.morale.text:GetText() )

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].morale.text:SetHeight( Group.Font[ Group.Settings.morale_font_type ].size[ Group.Settings.morale_font_size ] )
                                        Group.Party[ i ].morale.text:SetFont( Group:GetFont( Group.Settings.morale_font_type, Group.Settings.morale_font_size ) )
                                        Group.Party[ i ].morale.text:SetText( Group.Party[ i ].morale.text:GetText() )
                                    end

                                    main.morale_text_outline:SetChecked( Group.Default_Settings.morale_font_outline )
                                end
                            end )
                        )

                        ui:AddFiller( 0, UI.Spacing )

                        ui:AddItem(
                            UI:Create( "TEXT", ui, function( ui )
                                ui:SetSize( 360, 16 )
                                ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                                ui:SetText( "Outline" )

                                main.morale_text_outline = UI:Create( "CHECKBOX", ui, function( ui )
                                    ui:SetSize( 16, 16 )
                                    ui:SetPos( 75 ,0 )
                                    ui:SetChecked( Group.Settings.morale_font_outline )
                    
                                    function ui:CheckedChanged()
                                        local checked = self:IsChecked()
                    
                                        Group.Settings.morale_font_outline = checked
                    
                                        if checked then
                                            main.Frame.morale.text:SetFontStyle( Turbine.UI.FontStyle.Outline )
                                        else
                                            main.Frame.morale.text:SetFontStyle( Turbine.UI.FontStyle.None )
                                        end

                                        main.Frame.morale.text:SetText( main.Frame.morale.text:GetText() )
        
                                        for i = 1, #Group.Party do
                                            if checked then
                                                Group.Party[ i ].morale.text:SetFontStyle( Turbine.UI.FontStyle.Outline )
                                            else
                                                Group.Party[ i ].morale.text:SetFontStyle( Turbine.UI.FontStyle.None )
                                            end
        
                                            Group.Party[ i ].morale.text:SetText( Group.Party[ i ].morale.text:GetText() )
                                        end
                    
                                        Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                    end
                                end )
                            end )
                        )

                        ui:SetHeightToChildren()
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Color" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Morale Text
                ui:AddItem(
                    UI:Create( "COLOR_SELECT", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetInternalColor( Group.Settings.Color.Morale_Text )
                        ui:SetDefaultColor( Group.Default_Settings.Color.Morale_Text )
                        ui:SetBackgroundColor( Group.Settings.Color.Background )

                        main.select_unique_morale_text = ui

                        if Group.Settings.enable_unique_player_morale_color then
                            ui:SetLayerColor( Group.Default_Settings.Color.Unique_Morale )
                        else
                            ui:SetLayerColor( Group.Default_Settings.Color.Morale )
                        end

                        ui:EnableLayer( true )

                        function ui:ColorChanged( color )
                            Group.Settings.Color.Morale_Text = color

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            main.Frame.morale.text:SetForeColor( color )

                            for i = 1, #Group.Party do
                                Group.Party[ i ].morale.text:SetForeColor( color )
                            end
                        end

                        function ui:ColorSliderChanged( color )
                            Group.Settings.Color.Morale_Text = color

                            main.Frame.morale.text:SetForeColor( color )

                            for i = 1, #Group.Party do
                                Group.Party[ i ].morale.text:SetForeColor( color )
                            end
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "DIVIDER", ui, function( ui )
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Effect Duration" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Effect Duration
                ui:AddItem(
                    UI:Create( "LIST", ui, function( ui )
                        ui:SetSize( 360, 64 + 16 + UI.Spacing )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        ui:AddItem(
                            UI:Create( "SLIDER", ui, function( ui )
                                ui:SetWidth( 360 )
                                ui:SetRange( 1, #Group.Font )
                                ui:SetValueAlignment( 6 )
                                ui:SetValue( Group.Settings.effect_font_type, true )
                                ui:SetKey( "Type" )
                                ui:SetKeySize( 32 )
                                ui:SetValueSize( 144 )
                                ui:SetText( Group.Font[ Group.Settings.effect_font_type ].name )

                                main.slider_effect_font_type = ui

                                function ui:ValueChanged( value )
                                    Group.Settings.effect_font_type = value
                                    Group.Settings.effect_font_size = 1

                                    self:SetText( Group.Font[ value ].name )

                                    main.slider_effect_font_size:SetRange( 1, #Group.Font[ value ].size )
                                    main.slider_effect_font_size:SetValue( 1, true )
                                    main.slider_effect_font_size:SetText( Group.Font[ Group.Settings.effect_font_type ].size[ Group.Settings.effect_font_size ] )

                                    for i = 1, #main.Frame.effect do
                                        main.Frame.effect[ i ].text:SetFont( Group:GetFont( Group.Settings.effect_font_type, Group.Settings.effect_font_size ) )
                                        main.Frame.effect[ i ].text:SetText( main.Frame.effect[ i ].text:GetText() )
                                    end

                                    for i = 1, #Group.Party do
                                        for k = 1, #Group.Party[ i ].effect do
                                            Group.Party[ i ].effect[ k ].text:SetFont( Group:GetFont( Group.Settings.effect_font_type, Group.Settings.effect_font_size ) )
                                        end
                                    end

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                end

                                function ui:SliderChanged( value )
                                    Group.Settings.effect_font_type = value
                                    Group.Settings.effect_font_size = 1

                                    self:SetText( Group.Font[ value ].name )

                                    main.slider_effect_font_size:SetRange( 1, #Group.Font[ value ].size )
                                    main.slider_effect_font_size:SetValue( 1, true )
                                    main.slider_effect_font_size:SetText( Group.Font[ Group.Settings.effect_font_type ].size[ Group.Settings.effect_font_size ] )

                                    for i = 1, #main.Frame.effect do
                                        main.Frame.effect[ i ].text:SetFont( Group:GetFont( Group.Settings.effect_font_type, Group.Settings.effect_font_size ) )
                                        main.Frame.effect[ i ].text:SetText( main.Frame.effect[ i ].text:GetText() )
                                    end

                                    for i = 1, #Group.Party do
                                        for k = 1, #Group.Party[ i ].effect do
                                            Group.Party[ i ].effect[ k ].text:SetFont( Group:GetFont( Group.Settings.effect_font_type, Group.Settings.effect_font_size ) )
                                        end
                                    end
                                end
                            end )
                        )

                        ui:AddFiller( 0, UI.Spacing )

                        ui:AddItem(
                            UI:Create( "SLIDER_RESET", ui, function( ui )
                                ui:SetWidth( 360 )
                                ui:SetRange( 1, #Group.Font[ Group.Settings.effect_font_type ].size )
                                ui:SetValue( Group.Settings.effect_font_size, true )
                                ui:SetKey( "Size" )
                                ui:SetKeySize( 32 )
                                ui:SetText( Group.Font[ Group.Settings.effect_font_type ].size[ Group.Settings.effect_font_size ] )

                                main.slider_effect_font_size = ui

                                function ui:ValueChanged( value )
                                    Group.Settings.effect_font_size = value

                                    self:SetText( Group.Font[ Group.Settings.effect_font_type ].size[ Group.Settings.effect_font_size ] )

                                    for i = 1, #main.Frame.effect do
                                        main.Frame.effect[ i ].text:SetFont( Group:GetFont( Group.Settings.effect_font_type, Group.Settings.effect_font_size ) )
                                        main.Frame.effect[ i ].text:SetText( main.Frame.effect[ i ].text:GetText() )
                                    end

                                    for i = 1, #Group.Party do
                                        for k = 1, #Group.Party[ i ].effect do
                                            Group.Party[ i ].effect[ k ].text:SetFont( Group:GetFont( Group.Settings.effect_font_type, Group.Settings.effect_font_size ) )
                                        end
                                    end

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                end

                                function ui:SliderChanged( value )
                                    Group.Settings.effect_font_size = value

                                    self:SetText( Group.Font[ Group.Settings.effect_font_type ].size[ Group.Settings.effect_font_size ] )

                                    for i = 1, #main.Frame.effect do
                                        main.Frame.effect[ i ].text:SetFont( Group:GetFont( Group.Settings.effect_font_type, Group.Settings.effect_font_size ) )
                                        main.Frame.effect[ i ].text:SetText( main.Frame.effect[ i ].text:GetText() )
                                    end

                                    for i = 1, #Group.Party do
                                        for k = 1, #Group.Party[ i ].effect do
                                            Group.Party[ i ].effect[ k ].text:SetFont( Group:GetFont( Group.Settings.effect_font_type, Group.Settings.effect_font_size ) )
                                        end
                                    end
                                end

                                function ui:Reset()
                                    Group.Settings.effect_font_type = Group.Default_Settings.effect_font_type
                                    Group.Settings.effect_font_size = Group.Default_Settings.effect_font_size

                                    main.slider_effect_font_type:SetValue( Group.Default_Settings.effect_font_type, true )
                                    main.slider_effect_font_type:SetText( Group.Font[ Group.Default_Settings.effect_font_type ].name )

                                    self:SetRange( 1, #Group.Font[ Group.Default_Settings.effect_font_type ].size )
                                    self:SetValue( Group.Default_Settings.effect_font_size, true )
                                    self:SetText( Group.Font[ Group.Default_Settings.effect_font_type ].size[ Group.Default_Settings.effect_font_size ] )

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                                    for i = 1, #main.Frame.effect do
                                        main.Frame.effect[ i ].text:SetFont( Group:GetFont( Group.Settings.effect_font_type, Group.Settings.effect_font_size ) )
                                        main.Frame.effect[ i ].text:SetText( main.Frame.effect[ i ].text:GetText() )
                                    end

                                    for i = 1, #Group.Party do
                                        for k = 1, #Group.Party[ i ].effect do
                                            Group.Party[ i ].effect[ k ].text:SetFont( Group:GetFont( Group.Settings.effect_font_type, Group.Settings.effect_font_size ) )
                                        end
                                    end

                                    main.effect_outline:SetChecked( Group.Default_Settings.effect_font_outline )
                                end
                            end )
                        )

                        ui:AddFiller( 0, UI.Spacing )

                        ui:AddItem(
                            UI:Create( "TEXT", ui, function( ui )
                                ui:SetSize( 360, 16 )
                                ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                                ui:SetText( "Outline" )

                                main.effect_outline = UI:Create( "CHECKBOX", ui, function( ui )
                                    ui:SetSize( 16, 16 )
                                    ui:SetPos( 75, 0 )
                                    ui:SetChecked( Group.Settings.effect_font_outline )
                    
                                    function ui:CheckedChanged()
                                        local checked = self:IsChecked()
                    
                                        Group.Settings.effect_font_outline = checked
                                        
                                        for i = 1, #main.Frame.effect do
                                            if checked then
                                                main.Frame.effect[ i ].text:SetFontStyle( Turbine.UI.FontStyle.Outline )
                                            else
                                                main.Frame.effect[ i ].text:SetFontStyle( Turbine.UI.FontStyle.None )
                                            end

                                            main.Frame.effect[ i ].text:SetText( main.Frame.effect[ i ].text:GetText() )
                                        end
    
                                        for i = 1, #Group.Party do
                                            for k = 1, #Group.Party[ i ].effect do
                                                if checked then
                                                    Group.Party[ i ].effect[ k ].text:SetFontStyle( Turbine.UI.FontStyle.Outline )
                                                else
                                                    Group.Party[ i ].effect[ k ].text:SetFontStyle( Turbine.UI.FontStyle.None )
                                                end
                                            end
                                        end
                    
                                        Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                    end
                                end )
                            end )
                        )

                        ui:SetHeightToChildren()
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "DIVIDER", ui, function( ui )
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Special Effect Duration" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Special Effect Duration
                ui:AddItem(
                    UI:Create( "LIST", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetColor( 0, 100, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        ui:AddItem(
                            UI:Create( "SLIDER", ui, function( ui )
                                ui:SetWidth( 360 )
                                ui:SetRange( 1, #Group.Font )
                                ui:SetValueAlignment( 6 )
                                ui:SetValue( Group.Settings.special_effect_font_type, true )
                                ui:SetKey( "Type" )
                                ui:SetKeySize( 32 )
                                ui:SetValueSize( 144 )
                                ui:SetText( Group.Font[ Group.Settings.special_effect_font_type ].name )

                                main.slider_special_effect_font_type = ui

                                function ui:ValueChanged( value )
                                    Group.Settings.special_effect_font_type = value
                                    Group.Settings.special_effect_font_size = 1

                                    self:SetText( Group.Font[ value ].name )

                                    main.slider_special_effect_font_size:SetRange( 1, #Group.Font[ value ].size )
                                    main.slider_special_effect_font_size:SetValue( 1, true )
                                    main.slider_special_effect_font_size:SetText( Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] )

                                    main.Frame.special_text:SetHeight( Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] )
                                    main.Frame.special_text:SetFont( Group:GetFont( Group.Settings.special_effect_font_type, Group.Settings.special_effect_font_size ) )
                                    main.Frame.special_text:SetText( main.Frame.special_text:GetText() )

                                    main.Frame.special:PositionChanged()

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].special_text:SetHeight( Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] )
                                        Group.Party[ i ].special_text:SetFont( Group:GetFont( Group.Settings.special_effect_font_type, Group.Settings.special_effect_font_size ) )

                                        Group.Party[ i ].special:PositionChanged()
                                    end

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                end

                                function ui:SliderChanged( value )
                                    Group.Settings.special_effect_font_type = value
                                    Group.Settings.special_effect_font_size = 1

                                    self:SetText( Group.Font[ value ].name )

                                    main.slider_special_effect_font_size:SetRange( 1, #Group.Font[ value ].size )
                                    main.slider_special_effect_font_size:SetValue( 1, true )
                                    main.slider_special_effect_font_size:SetText( Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] )

                                    main.Frame.special_text:SetHeight( Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] )
                                    main.Frame.special_text:SetFont( Group:GetFont( Group.Settings.special_effect_font_type, Group.Settings.special_effect_font_size ) )
                                    main.Frame.special_text:SetText( main.Frame.special_text:GetText() )

                                    main.Frame.special:PositionChanged()

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].special_text:SetHeight( Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] )
                                        Group.Party[ i ].special_text:SetFont( Group:GetFont( Group.Settings.special_effect_font_type, Group.Settings.special_effect_font_size ) )

                                        Group.Party[ i ].special:PositionChanged()
                                    end
                                end
                            end )
                        )

                        ui:AddFiller( 0, UI.Spacing )

                        ui:AddItem(
                            UI:Create( "SLIDER_RESET", ui, function( ui )
                                ui:SetWidth( 360 )
                                ui:SetRange( 1, #Group.Font[ Group.Settings.special_effect_font_type ].size )
                                ui:SetValue( Group.Settings.special_effect_font_size, true )
                                ui:SetKey( "Size" )
                                ui:SetKeySize( 32 )
                                ui:SetText( Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] )

                                main.slider_special_effect_font_size = ui

                                function ui:ValueChanged( value )
                                    Group.Settings.special_effect_font_size = value

                                    self:SetText( Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] )

                                    main.Frame.special_text:SetHeight( Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] )
                                    main.Frame.special_text:SetFont( Group:GetFont( Group.Settings.special_effect_font_type, Group.Settings.special_effect_font_size ) )
                                    main.Frame.special_text:SetText( main.Frame.special_text:GetText() )

                                    main.Frame.special:PositionChanged()

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].special_text:SetHeight( Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] )
                                        Group.Party[ i ].special_text:SetFont( Group:GetFont( Group.Settings.special_effect_font_type, Group.Settings.special_effect_font_size ) )

                                        Group.Party[ i ].special:PositionChanged()
                                    end

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                end

                                function ui:SliderChanged( value )
                                    Group.Settings.special_effect_font_size = value

                                    self:SetText( Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] )

                                    main.Frame.special_text:SetHeight( Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] )
                                    main.Frame.special_text:SetFont( Group:GetFont( Group.Settings.special_effect_font_type, Group.Settings.special_effect_font_size ) )
                                    main.Frame.special_text:SetText( main.Frame.special_text:GetText() )

                                    main.Frame.special:PositionChanged()

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].special_text:SetHeight( Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] )
                                        Group.Party[ i ].special_text:SetFont( Group:GetFont( Group.Settings.special_effect_font_type, Group.Settings.special_effect_font_size ) )

                                        Group.Party[ i ].special:PositionChanged()
                                    end
                                end

                                function ui:Reset()
                                    Group.Settings.special_effect_font_type = Group.Default_Settings.special_effect_font_type
                                    Group.Settings.special_effect_font_size = Group.Default_Settings.special_effect_font_size

                                    main.slider_special_effect_font_type:SetValue( Group.Default_Settings.special_effect_font_type, true )
                                    main.slider_special_effect_font_type:SetText( Group.Font[ Group.Default_Settings.special_effect_font_type ].name )

                                    self:SetRange( 1, #Group.Font[ Group.Default_Settings.special_effect_font_type ].size )
                                    self:SetValue( Group.Default_Settings.special_effect_font_size, true )
                                    self:SetText( Group.Font[ Group.Default_Settings.special_effect_font_type ].size[ Group.Default_Settings.special_effect_font_size ] )

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                                    main.Frame.special_text:SetHeight( Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] )
                                    main.Frame.special_text:SetFont( Group:GetFont( Group.Settings.special_effect_font_type, Group.Settings.special_effect_font_size ) )
                                    main.Frame.special_text:SetText( main.Frame.special_text:GetText() )

                                    main.Frame.special:PositionChanged()

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ].special_text:SetHeight( Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] )
                                        Group.Party[ i ].special_text:SetFont( Group:GetFont( Group.Settings.special_effect_font_type, Group.Settings.special_effect_font_size ) )

                                        Group.Party[ i ].special:PositionChanged()
                                    end

                                    main.special_effect_outline:SetChecked( Group.Default_Settings.special_effect_font_outline )
                                end
                            end )
                        )

                        ui:AddFiller( 0, UI.Spacing )

                        ui:AddItem(
                            UI:Create( "TEXT", ui, function( ui )
                                ui:SetSize( 360, 16 )
                                ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                                ui:SetText( "Outline" )

                                main.special_effect_outline = UI:Create( "CHECKBOX", ui, function( ui )
                                    ui:SetSize( 16, 16 )
                                    ui:SetPos( 75, 0 )
                                    ui:SetChecked( Group.Settings.special_effect_font_outline )
                    
                                    function ui:CheckedChanged()
                                        local checked = self:IsChecked()
                    
                                        Group.Settings.special_effect_font_outline = checked
                    
                                        if checked then
                                            main.Frame.special_text:SetFontStyle( Turbine.UI.FontStyle.Outline )
                                        else
                                            main.Frame.special_text:SetFontStyle( Turbine.UI.FontStyle.None )
                                        end

                                        main.Frame.special_text:SetText( main.Frame.special_text:GetText() )
    
                                        for i = 1, #Group.Party do
                                            if checked then
                                                Group.Party[ i ].special_text:SetFontStyle( Turbine.UI.FontStyle.Outline )
                                            else
                                                Group.Party[ i ].special_text:SetFontStyle( Turbine.UI.FontStyle.None )
                                            end
                                        end
                    
                                        Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )
                                    end
                                end )
                            end )
                        )

                        ui:SetHeightToChildren()
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Color" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Special Effect Duration Text
                ui:AddItem(
                    UI:Create( "COLOR_SELECT", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetInternalColor( Group.Settings.Color.Special_Effect )
                        ui:SetDefaultColor( Group.Default_Settings.Color.Special_Effect )
                        ui:SetBackgroundColor( Group.Settings.Color.Background )

                        main.select_special_effect = ui

                        if Group.Settings.enable_unique_player_morale_color then
                            ui:SetLayerColor( Group.Default_Settings.Color.Unique_Morale )
                        else
                            ui:SetLayerColor( Group.Default_Settings.Color.Morale )
                        end

                        ui:EnableLayer( true )

                        function ui:ColorChanged( color )
                            Group.Settings.Color.Special_Effect = color

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            main.Frame.special_text:SetForeColor( color )

                            for i = 1, #Group.Party do
                                Group.Party[ i ].special_text:SetForeColor( color )
                            end
                        end

                        function ui:ColorSliderChanged( color )
                            Group.Settings.Color.Special_Effect = color

                            main.Frame.special_text:SetForeColor( color )

                            for i = 1, #Group.Party do
                                Group.Party[ i ].special_text:SetForeColor( color )
                            end
                        end
                    end )
                )

                ui:SetHeightToChildren( 16 )
            end )
        )

        --Class Colors
        main.rightBar:AddItem(
            UI:Create( "LIST", main.rightBar, function( ui )
                ui:SetWidth( 360 )
                ui:SetColor( 200, 0, 200, 0 )
                ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                ui:AddItem(
                    UI:Create( "HEADER", ui, function( ui )
                        ui:SetText( "Unique Class Morale Color" )
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Class" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Class
                ui:AddItem(
                    UI:Create( "DROPDOWN", ui, function( ui )
                        ui:SetWidth( 360 )

                        local tbl = {
                            "Hunter",
                            "Warden",
                            "Burglar",
                            "Captain",
                            "Champion",
                            "Guardian",
                            "Minstrel",
                            "Beorning",
                            "LoreMaster",
                            "RuneKeeper",

                            "Weaver",
                            "Reaver",
                            "Defiler",
                            "Stalker",
                            "WarLeader",
                            "BlackArrow"
                        }

                        for i = 1, #tbl do
                            local class = tbl[ i ]

                            local a = string.sub( class, 1, 1 )
                            local b = string.lower( string.sub( class, 2, #class ) )

                            local item = ui:Add( class, function( ui, parent )
                                main.selected_class = class

                                main.select_unique_class_morale:SetInternalColor( Group.Settings.Color.Class[ Turbine.Gameplay.Class[ class ] ] )
                                main.select_unique_class_morale:SetDefaultColor( Group.Default_Settings.Color.Class[ Turbine.Gameplay.Class[ class ] ] )

                                parent.text:SetText( a .. b )
                            end )

                            if i == 7 then
                                ui:SetSelected( item )

                                main.selected_class = class

                                ui.text:SetText( a .. b )
                            end

                            item:SetText( a .. b )
                        end
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro16 )
                        ui:SetText( "Color" )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Class Morale
                ui:AddItem(
                    UI:Create( "COLOR_SELECT", ui, function( ui )
                        ui:SetWidth( 360 )
                        ui:SetInternalColor( Group.Settings.Color.Class[ Turbine.Gameplay.Class[ main.selected_class ] ] )
                        ui:SetDefaultColor( Group.Default_Settings.Color.Class[ Turbine.Gameplay.Class[ main.selected_class ] ] )
                        ui:SetBackgroundColor( Group.Settings.Color.Background )

                        main.select_unique_class_morale = ui

                        function ui:ColorChanged( color )
                            Group.Settings.Color.Class[ Turbine.Gameplay.Class[ main.selected_class ] ] = color

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            if not Group.Settings.enable_unique_player_morale_color and Group.Settings.enable_unique_class_morale_color then
                                if Turbine.Gameplay.Class[ main.selected_class ] == Player:GetClass() then
                                    main.Frame.morale:SetColor( color )
                                end
                            end
                        end

                        function ui:ColorSliderChanged( color )
                            Group.Settings.Color.Class[ Turbine.Gameplay.Class[ main.selected_class ] ] = color

                            if not Group.Settings.enable_unique_player_morale_color and Group.Settings.enable_unique_class_morale_color then
                                if Turbine.Gameplay.Class[ main.selected_class ] == Player:GetClass() then
                                    main.Frame.morale:SetColor( color )
                                end
                            end
                        end
                    end )
                )

                ui:SetHeightToChildren()
            end )
        )

        -----------------------------------------------------

        main.leftBar:SetHeightToChildren()
        main.rightBar:SetHeightToChildren()

        local height = main.leftBar:GetHeight()

        if height < main.rightBar:GetHeight() then height = main.rightBar:GetHeight() end

        main.scroll.container:SetHeight( height )

        -----------------------------------------------------
        --Frame Preview Header
        main.sideBar:AddItem(
            UI:Create( "HEADER", main.sideBar, function( ui )
                ui:SetText( "Frame Preview" )
            end )
        )

        main.sideBar:AddFiller( 0, 16 )

        --Frame Preview
        main.sideBar:AddItem(
            UI:Create( "BOX", main.sideBar, function( ui )
                ui:SetSize( 360, 360 )
                ui:SetColor( 0, 0, 0, 0 )

                UI:Create( "BORDER", ui, function( ui )
                    ui:SetSize( 360, 360 )
                    ui:SetBorderSize( 1 )
                    ui:SetBorderColor( Color( 100, 100, 100 ) )
                end )

                main.Frame = UI:Create( "BOX", ui, function( ui )
                    ui:SetSize( Group.Settings.vitals_x, Group.Settings.vitals_y )
                    ui:SetPos( 360 / 2 - Group.Settings.vitals_x / 2, 360 / 2 - Group.Settings.vitals_y / 2 )
                    ui:SetColor( Group.Settings.Color.Background )

                    main.Pos = {
                        [ 1 ] = function( ui, x, y, w, h ) ui:SetPos( x, y ) end, --Top left
                        [ 2 ] = function( ui, x, y, w, h ) ui:SetPos( Group.Settings.vitals_x - Group.Settings.power_x - x - w, y ) end, --Top Right
                        [ 3 ] = function( ui, x, y, w, h ) ui:SetPos( Group.Settings.vitals_x - Group.Settings.power_x - x - w, Group.Settings.vitals_y - y - h ) end, --Bottom Right
                        [ 4 ] = function( ui, x, y, w, h ) ui:SetPos( x, Group.Settings.vitals_y - y - h ) end, --Bottom Left
                        [ 5 ] = function( ui, x, y, w, h ) ui:SetPos( Group.Settings.vitals_x / 2 - w / 2 + x - Group.Settings.power_x, Group.Settings.vitals_y / 2 - h / 2 + y ) end --Center
                    }

                    ui.power = UI:Create( "BOX", ui, function( ui, parent )
                        ui:SetSize( Group.Settings.power_x, Group.Settings.vitals_y )
                        ui:SetColor( Group.Settings.Color.Power )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        function ui:SizeChanged()
                            local w = self:GetWidth()

                            parent.morale:SetPos( w, 0 )
                        end
                    end )

                    ui.morale = UI:Create( "BOX", ui, function( ui, parent )
                        ui:SetPos( Group.Settings.power_x, 0 )
                        ui:SetSize( Group.Settings.vitals_x - Group.Settings.power_x, Group.Settings.vitals_y )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        if Group.Settings.enable_unique_player_morale_color then
                            ui:SetColor( Group.Settings.Color.Unique_Morale )
                        else
                            ui:SetColor( Group.Settings.Color.Morale )
                        end

                        ui.text = UI:Create( "TEXT", ui, function( ui, parent )
                            ui:SetMultiline( false )
                            ui:SetSize( 256, Group.Font[ Group.Settings.morale_font_type ].size[ Group.Settings.morale_font_size ] )
                            ui:SetFont( Group:GetFont( Group.Settings.morale_font_type, Group.Settings.morale_font_size ) )
                            ui:SetVisible( Group.Settings.enable_morale_text )

                            if Group.Settings.Frame.Morale_Text.anchor == 1 or Group.Settings.Frame.Morale_Text.anchor == 4 then
                                ui:SetTextAlignment( 4 )
                            elseif Group.Settings.Frame.Morale_Text.anchor == 5 then
                                ui:SetTextAlignment( 5 )
                            else
                                ui:SetTextAlignment( 6 )
                            end
                
                            if Group.Settings.morale_font_outline then
                                ui:SetFontStyle( Turbine.UI.FontStyle.Outline )
                            else
                                ui:SetFontStyle( Turbine.UI.FontStyle.None )
                            end
                
                            ui:SetForeColor( Group.Settings.Color.Morale_Text )

                            ui.format = {
                                [ 1 ] = function() --%
                                    local percent = ( Player:GetMorale() / Player:GetMaxMorale() ) * 100
                    
                                    ui:SetText( math.round( percent ) .. "%" ) 
                                end,
                                [ 2 ] = function() --Current
                                    ui:SetText( math.format( math.round( Player:GetMorale() ) ) ) 
                                end,
                                [ 3 ] = function() --Current + %
                                    local percent = ( Player:GetMorale() / Player:GetMaxMorale() ) * 100
                    
                                    ui:SetText( math.format( math.round( Player:GetMorale() ) ) .. " " .. math.round( percent ) .. "%" ) 
                                end,
                                [ 4 ] = function() --Current / Max
                                    ui:SetText( math.format( math.round( Player:GetMorale() ) ) .. "/" .. math.format( math.round( Player:GetMaxMorale() ) ) ) 
                                end,
                                [ 5 ] = function() --Current / Max + %
                                    local percent = ( Player:GetMorale() / Player:GetMaxMorale() ) * 100
                    
                                    ui:SetText( math.format( math.round( Player:GetMorale() ) ) .. "/" .. math.format( math.round( Player:GetMaxMorale() ) ) .. " " .. math.round( percent ) .. "%" )
                                end
                            }

                            ui.format[ Group.Settings.morale_text_format ]()

                            main.Pos[ Group.Settings.Frame.Morale_Text.anchor ]( ui, Group.Settings.Frame.Morale_Text.x, Group.Settings.Frame.Morale_Text.y, ui:GetSize() )

                            function ui:SizeChanged()
                                main.Pos[ Group.Settings.Frame.Morale_Text.anchor ]( self, Group.Settings.Frame.Morale_Text.x, Group.Settings.Frame.Morale_Text.y, self:GetSize() )
                            end
                        end )

                        parent.name = UI:Create( "TEXT", ui, function( ui, parent )
                            ui:SetMultiline( false )
                            ui:SetSize( Group.Settings.name_width, Group.Font[ Group.Settings.player_font_type ].size[ Group.Settings.player_font_size ] )
                            ui:SetVisible( Group.Settings.enable_player_name )
                            ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                            if Group.Settings.Frame.Name.anchor == 1 or Group.Settings.Frame.Name.anchor == 4 then
                                ui:SetTextAlignment( 4 )
                            elseif Group.Settings.Frame.Name.anchor == 5 then
                                ui:SetTextAlignment( 5 )
                            else
                                ui:SetTextAlignment( 6 )
                            end
                            
                            ui:SetFont( Group:GetFont( Group.Settings.player_font_type, Group.Settings.player_font_size ) )

                            if Group.Settings.player_font_outline then
                                ui:SetFontStyle( Turbine.UI.FontStyle.Outline )
                            else
                                ui:SetFontStyle( Turbine.UI.FontStyle.None )
                            end
                            
                            if Group.Settings.enable_unique_player_name_color then
                                ui:SetForeColor( Group.Settings.Color.Unique_Name )
                                ui:SetOutlineColor( Group.Settings.Color.Unique_Name_Outline )
                            else
                                ui:SetForeColor( Group.Settings.Color.Name )
                                ui:SetOutlineColor( Group.Settings.Color.Name_Outline )
                            end

                            ui:SetText( Player:GetName() )

                            main.Pos[ Group.Settings.Frame.Name.anchor ]( ui, Group.Settings.Frame.Name.x, Group.Settings.Frame.Name.y, ui:GetSize() )

                            function ui:SizeChanged()
                                main.Pos[ Group.Settings.Frame.Name.anchor ]( self, Group.Settings.Frame.Name.x, Group.Settings.Frame.Name.y, self:GetSize() )
                            end
                        end )
    
                        parent.class = UI:Create( "BOX", ui, function( ui, parent )
                            ui:SetSize( 20, 20 )
                            ui:SetStretchMode( 1 )
                            ui:SetSize( Group.Settings.class_icon_size, Group.Settings.class_icon_size )
                            ui:SetColor( 0, 0, 0, 0 )
                            ui:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend )
                            ui:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
                            ui:SetBackground( Group.ClassIcon[ Player:GetClass() ] )
                            ui:SetVisible( Group.Settings.enable_class_icon )

                            main.Pos[ Group.Settings.Frame.Class.anchor ]( ui, Group.Settings.Frame.Class.x, Group.Settings.Frame.Class.y, Group.Settings.class_icon_size, Group.Settings.class_icon_size )

                            function ui:SizeChanged()
                                main.Pos[ Group.Settings.Frame.Class.anchor ]( self, Group.Settings.Frame.Class.x, Group.Settings.Frame.Class.y, Group.Settings.class_icon_size, Group.Settings.class_icon_size )
                            end
                        end )
    
                        parent.leader = UI:Create( "BOX", ui, function( ui, parent )
                            ui:SetSize( 16, 16 )
                            ui:SetStretchMode( 1 )
                            ui:SetSize( Group.Settings.leader_icon_size, Group.Settings.leader_icon_size )
                            ui:SetColor( 0, 0, 0, 0 )
                            ui:SetBackground( 0x410081C3 )
                            ui:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend )
                            ui:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )
                            ui:SetVisible( Group.Settings.enable_leader_icon )
                            
                            main.Pos[ Group.Settings.Frame.Leader.anchor ]( ui, Group.Settings.Frame.Leader.x, Group.Settings.Frame.Leader.y, Group.Settings.leader_icon_size, Group.Settings.leader_icon_size )

                            function ui:SizeChanged()
                                main.Pos[ Group.Settings.Frame.Leader.anchor ]( self, Group.Settings.Frame.Leader.x, Group.Settings.Frame.Leader.y, Group.Settings.leader_icon_size, Group.Settings.leader_icon_size )
                            end
                        end )

                        parent.special_text = UI:Create( "TEXT", ui, function( ui, parent )
                            ui:SetSize( 256, Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] )
                            ui:SetTextAlignment( 6 )
                            ui:SetMultiline( false )
                            ui:SetVisible( Group.Settings.enable_special_effect_duration )

                            ui:SetFont( Group:GetFont( Group.Settings.special_effect_font_type, Group.Settings.special_effect_font_size ) )

                            if Group.Settings.special_effect_font_outline then
                                ui:SetFontStyle( Turbine.UI.FontStyle.Outline )
                            else
                                ui:SetFontStyle( Turbine.UI.FontStyle.None )
                            end

                            if Group.Settings.enable_special_effect then
                                ui:SetVisible( Group.Settings.enable_special_effect_duration )
                            else
                                ui:SetVisible( false )
                            end

                            ui:SetForeColor( Group.Settings.Color.Special_Effect )
                            ui:SetText( "00:00" )
                        end )
    
                        parent.special = UI:Create( "BOX", ui, function( ui, parent )
                            ui:SetSize( Group.Settings.special_effect_size, Group.Settings.special_effect_size )
                            ui:SetColor( 50, 50, 50, 255 )
                            ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )
                            ui:SetVisible( Group.Settings.enable_special_effect )

                            function ui:PositionChanged()
                                local x, y = self:GetPos()

                                if Group.Settings.Frame.Special_Effect.anchor == 1 or Group.Settings.Frame.Special_Effect.anchor == 4 then
                                    parent:GetParent().special_text:SetTextAlignment( 4 )

                                    parent:GetParent().special_text:SetPos( x + Group.Settings.special_effect_size + UI.Spacing, 
                                    y + Group.Settings.special_effect_size / 2 - Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] / 2 )
                                else
                                    parent:GetParent().special_text:SetTextAlignment( 6 )

                                    parent:GetParent().special_text:SetPos( x - 256 - UI.Spacing, y + Group.Settings.special_effect_size / 2 - Group.Font[ Group.Settings.special_effect_font_type ].size[ Group.Settings.special_effect_font_size ] / 2 )
                                end
                            end

                            function ui:SizeChanged()
                                main.Pos[ Group.Settings.Frame.Special_Effect.anchor ]( self, Group.Settings.Frame.Special_Effect.x, Group.Settings.Frame.Special_Effect.y, Group.Settings.special_effect_size, Group.Settings.special_effect_size )
                            end

                            main.Pos[ Group.Settings.Frame.Special_Effect.anchor ]( ui, Group.Settings.Frame.Special_Effect.x, Group.Settings.Frame.Special_Effect.y, Group.Settings.special_effect_size, Group.Settings.special_effect_size )
                        end )

                        parent.effect = {}

                        for i = 1, 20 do
                            parent.effect[ i ] = UI:Create( "BOX", ui, function( ui )
                                ui:SetColor( 50, 50, 50, 255 )
                                ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                                ui.offset = {
                                    [ 1 ] = function( x, y, w, h, ex, ey ) 
                                        local offset_x = Group.Settings.effect_size * ( x - 1 ) + Group.Settings.effect_spacing * ( x - 1 ) + ex
                                        local offset_y = Group.Settings.effect_size * ( y - 1 ) + Group.Settings.effect_spacing * ( y - 1 ) + ey

                                        return offset_x, offset_y
                                    end,
                                    [ 2 ] = function( x, y, w, h, ex, ey ) 
                                        local offset_x = w - Group.Settings.effect_size * x - Group.Settings.effect_spacing * ( x - 1 ) - ex
                                        local offset_y = Group.Settings.effect_size * ( y - 1 ) + Group.Settings.effect_spacing * ( y - 1 ) + ey

                                        return offset_x, offset_y
                                    end,
                                    [ 3 ] = function( x, y, w, h, ex, ey ) 
                                        local offset_x = w - Group.Settings.effect_size * x - Group.Settings.effect_spacing * ( x - 1 ) - ex
                                        local offset_y = h - Group.Settings.effect_size * y - Group.Settings.effect_spacing * ( y - 1 ) - ey

                                        return offset_x, offset_y
                                    end,
                                    [ 4 ] = function( x, y, w, h, ex, ey ) 
                                        local offset_x = Group.Settings.effect_size * ( x - 1 ) + Group.Settings.effect_spacing * ( x - 1 ) + ex
                                        local offset_y = h - Group.Settings.effect_size * y - Group.Settings.effect_spacing * ( y - 1 ) - ey

                                        return offset_x, offset_y
                                    end
                                }

                                if i > main.effect_count then
                                    ui:SetVisible( false )
                                else
                                    ui:SetVisible( true )
                                end

                                ui.text = UI:Create( "TEXT", ui, function( ui )
                                    ui:SetSize( 32, 32 )
                                    ui:SetTextAlignment( 5 )
                                    ui:SetMultiline( false )
                                    ui:SetVisible( Group.Settings.enable_effect_duration )
                                    ui:SetFont( Group:GetFont( Group.Settings.effect_font_type, Group.Settings.effect_font_size ) )

                                    ui:SetText( i )

                                    if Group.Settings.effect_font_outline then
                                        ui:SetFontStyle( Turbine.UI.FontStyle.Outline )
                                    else
                                        ui:SetFontStyle( Turbine.UI.FontStyle.None )
                                    end
                                end )

                                ui:SetSize( 32, 32 )
                                ui:SetStretchMode( 1 )
                                ui:SetSize( Group.Settings.effect_size, Group.Settings.effect_size )
                            end )
                        end

                        function ui:PositionChanged()
                            parent.class:SetStretchMode( 1 )
                            parent.class:SetSize( Group.Settings.class_icon_size, Group.Settings.class_icon_size )

                            parent.leader:SetStretchMode( 1 )
                            parent.leader:SetSize( Group.Settings.leader_icon_size, Group.Settings.leader_icon_size )
                        end
                    end )

                    function ui:SizeChanged()
                        local w, h = self:GetSize()

                        self.power:SetHeight( h )
                        self.morale:SetSize( Group.Settings.vitals_x - self.power:GetWidth(), h )
                        self.morale:PositionChanged()

                        main.Pos[ Group.Settings.Frame.Name.anchor ]( self.name, Group.Settings.Frame.Name.x, Group.Settings.Frame.Name.y, self.name:GetSize() )
                        main.Pos[ Group.Settings.Frame.Class.anchor ]( self.class, Group.Settings.Frame.Class.x, Group.Settings.Frame.Class.y, Group.Settings.class_icon_size, Group.Settings.class_icon_size )
                        main.Pos[ Group.Settings.Frame.Leader.anchor ]( self.leader, Group.Settings.Frame.Leader.x, Group.Settings.Frame.Leader.y, Group.Settings.leader_icon_size, Group.Settings.leader_icon_size )
                        main.Pos[ Group.Settings.Frame.Morale_Text.anchor ]( self.morale.text, Group.Settings.Frame.Morale_Text.x, Group.Settings.Frame.Morale_Text.y, self.morale.text:GetSize() )
                        main.Pos[ Group.Settings.Frame.Special_Effect.anchor ]( self.special, Group.Settings.Frame.Special_Effect.x, Group.Settings.Frame.Special_Effect.y, Group.Settings.special_effect_size, Group.Settings.special_effect_size )

                        self:EffectLayout()
                    end


                    function ui:EffectLayout()
                        local count = 1

                        local row_x = Group.Settings.effect_row_count
                        local row_y = math.ceil( main.effect_count / Group.Settings.effect_row_count )

                        local w, h = self.morale:GetSize()

                        for y = 1, row_y do
                            for x = 1, row_x do
                                local offset_x, offset_y = self.effect[ count ].offset[ Group.Settings.Frame.Effect.anchor ]( x, y, w, h, Group.Settings.Frame.Effect.x, Group.Settings.Frame.Effect.y )

                                self.effect[ count ]:SetStretchMode( 1 )
                                self.effect[ count ]:SetSize( Group.Settings.effect_size, Group.Settings.effect_size )

                                self.effect[ count ]:SetPos( offset_x, offset_y )
                                
                                count = count + 1
                
                                if count > main.effect_count then return end
                            end
                        end
                    end

                    ui:EffectLayout()
                end )
            end )
        )

        main.sideBar:AddFiller( 0, 16 )

        function main:CreateEffectListItem( parent, name, track, track_self )
            return UI:Create( "BOX", parent, function( ui )
                ui:SetSize( 360 - 16 - UI.Spacing / 2, 16 * 2 + UI.Spacing * 3 + 1 )
                ui:SetColor( 255, 0, 0, 0 )
                ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                ui.name = name

                ui.hover = UI:Create( "BOX", ui, function( ui )
                    ui:SetPos( UI.Spacing + 1 )
                    ui:SetSize( 360 - 16 - UI.Spacing * 3, 16 * 2 + UI.Spacing * 3 )
                    ui:SetColor( 0, 0, 0, 0 )
                    ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )
                    ui:SetMouseVisible( false )
                end )

                UI:Create( "DIVIDER", ui, function( ui )
                    ui:SetWidth( 360 - 16 - UI.Spacing * 3 )
                    ui:SetPos( UI.Spacing + 1, 16 * 2 + UI.Spacing * 3 )
                end )

                function ui:MouseEnter()
                    if main.effect_list.selected == self then return end

                    ui.hover:SetColor( 50, 50, 50 )
                end

                function ui:MouseLeave()
                    if main.effect_list.selected == self then return end

                    ui.hover:SetColor( 0, 0, 0, 0 )
                end

                function ui:MouseUp()
                    if main.effect_list.selected == self then
                        main.effect_list.selected = nil

                        self.hover:SetColor( 50, 50, 50 )
                        self.text:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) )
                    else
                        if main.effect_list.selected then
                            main.effect_list.selected.hover:SetColor( 0, 0, 0, 0 )
                            main.effect_list.selected.text:SetForeColor( Turbine.UI.Color( 1, 1, 1 ) )
                        end

                        main.effect_list.selected = self

                        self.text:SetForeColor( Turbine.UI.Color( 0.5, 0.5, 0.5 ) )

                        ui.hover:SetColor( 50, 50, 50 )
                    end
                end

                ui.text = UI:Create( "TEXT", ui, function( ui )
                    ui:SetSize( 191, 16 )
                    ui:SetPos( UI.Spacing * 2, UI.Spacing )
                    ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 )
                    ui:SetTextAlignment( 4 )
                    ui:SetText( name )
                    ui:SetMouseVisible( false )
                end )

                UI:Create( "TEXT", ui, function( ui )
                    ui:SetSize( 360 - 16 - UI.Spacing * 3 - UI.Spacing * 2 - 16 + 5, 16 )
                    ui:SetPos( 0, UI.Spacing * 2 + 16 )
                    ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 )
                    ui:SetText( "Track Others" )
                    ui:SetTextAlignment( 6 )
                    ui:SetMouseVisible( false )
                end )

                UI:Create( "CHECKBOX", ui, function( ui )
                    ui:SetSize( 16, 16 )
                    ui:SetPos( 346 - UI.Spacing * 2 - 16 - 1 - UI.Spacing, UI.Spacing * 2 + 16 )
                    ui:SetChecked( track or false )

                    function ui:CheckedChanged()
                        local checked = self:IsChecked()

                        Group.Settings.effect[ name ] = checked

                        Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                        for i = 1, #Group.Party do
                            Group.Party[ i ]:RefreshEffects( Group.Party[ i ].player_effects, true )
                        end
                    end
                end )

                UI:Create( "TEXT", ui, function( ui )
                    ui:SetSize( 195 - UI.Spacing , 16 )
                    ui:SetPos( 0, UI.Spacing * 2 + 16 )
                    ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 )
                    ui:SetText( "Track Self" )
                    ui:SetTextAlignment( 6 )
                    ui:SetMouseVisible( false )
                end )

                UI:Create( "CHECKBOX", ui, function( ui )
                    ui:SetSize( 16, 16 )
                    ui:SetPos( 195, UI.Spacing * 2 + 16 )
                    ui:SetChecked( track_self or false )

                    function ui:CheckedChanged()
                        local checked = self:IsChecked()

                        Group.Settings.effect_self[ name ] = checked

                        Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                        for i = 1, #Group.Party do
                            Group.Party[ i ]:RefreshEffects( Group.Party[ i ].player_effects, true )
                        end
                    end
                end )

                UI:Create( "TEXT", ui, function( ui )
                    ui:SetSize( 360 - 16 - UI.Spacing * 3 - 16 + 3 - 16 * 2 - UI.Spacing , 16 )
                    ui:SetPos( 0, UI.Spacing )
                    ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 )
                    ui:SetText( "Max Stack" )
                    ui:SetTextAlignment( 6 )
                    ui:SetMouseVisible( false )
                end )

                local text = UI:Create( "TEXT", ui, function( ui )
                    ui:SetSize( 16, 16 )
                    ui:SetPos( 360 - 16 - UI.Spacing * 3 - 16 + 3 - 16, UI.Spacing )
                    ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 )
                    ui:SetText( Group.Settings.effect_stack[ name ] )
                    ui:SetTextAlignment( 5 )
                    ui:SetMouseVisible( false )
                end )

                UI:Create( "IBUTTON", ui, function( ui )
                    ui:SetSize( 16, 16 )
                    ui:SetPos( 360 - 16 - UI.Spacing * 3 - 16 + 3, UI.Spacing )
                    ui:SetBackground( "Darf/UI/Resources/arrow_right.tga" )
                    ui:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend )
                    ui:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )

                    function ui:MouseDown()
                        self:SetBackground( "Darf/UI/Resources/arrow_right_pressed.tga" )
                    end

                    function ui:MouseUp()
                        if not self:IsHovering() then return end

                        self:SetBackground( "Darf/UI/Resources/arrow_right_hover.tga" )

                        Group.Settings.effect_stack[ name ] = Group.Settings.effect_stack[ name ] + 1

                        if Group.Settings.effect_stack[ name ] > 10 then Group.Settings.effect_stack[ name ] = 10 end

                        text:SetText( Group.Settings.effect_stack[ name ] )

                        Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                        for i = 1, #Group.Party do
                            Group.Party[ i ]:RefreshEffects( Group.Party[ i ].player_effects, true )
                        end
                    end

                    function ui:MouseEnter()
                        self:SetBackground( "Darf/UI/Resources/arrow_right_hover.tga" )
                    end

                    function ui:MouseLeave()
                        self:SetBackground( "Darf/UI/Resources/arrow_right.tga" )
                    end
                end )

                UI:Create( "IBUTTON", ui, function( ui )
                    ui:SetSize( 16, 16 )
                    ui:SetPos( 360 - 16 - UI.Spacing * 3 - 16 + 3 - 16 * 2, UI.Spacing )
                    ui:SetBackground( "Darf/UI/Resources/arrow_left.tga" )
                    ui:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend )
                    ui:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )

                    function ui:MouseDown()
                        self:SetBackground( "Darf/UI/Resources/arrow_left_pressed.tga" )
                    end

                    function ui:MouseUp()
                        if not self:IsHovering() then return end

                        self:SetBackground( "Darf/UI/Resources/arrow_left_hover.tga" )

                        Group.Settings.effect_stack[ name ] = Group.Settings.effect_stack[ name ] - 1

                        if Group.Settings.effect_stack[ name ] < 1 then Group.Settings.effect_stack[ name ] = 1 end

                        text:SetText( Group.Settings.effect_stack[ name ] )

                        Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                        for i = 1, #Group.Party do
                            Group.Party[ i ]:RefreshEffects( Group.Party[ i ].player_effects, true )
                        end
                    end

                    function ui:MouseEnter()
                        self:SetBackground( "Darf/UI/Resources/arrow_left_hover.tga" )
                    end

                    function ui:MouseLeave()
                        self:SetBackground( "Darf/UI/Resources/arrow_left.tga" )
                    end
                end )
            end )
        end

        --Effects
        main.sideBar:AddItem(
            UI:Create( "LIST", main.sideBar, function( ui )
                ui:SetSize( 360, 20 + 16 + 172 + 20 + UI.Spacing * 3 + 13 * 2 + 24 + 16 )
                ui:SetColor( 0, 0, 0, 0 )
                ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                ui:AddItem(
                    UI:Create( "HEADER", ui, function( ui )
                        ui:SetText( "Effects" )
                    end )
                )

                ui:AddFiller( 0, 16 )

                main.effect_list_count = 0

                --Effect List
                ui:AddItem(
                    UI:Create( "SCROLLBOX", ui, function( ui )
                        ui:SetSize( 360, 172 )

                        main.effect_list = ui

                        ui.list:SetColor( 25, 25, 25, 255 )
                        ui.list:SetWidth( 360 - 16 - UI.Spacing / 2 )

                        ui:AddFiller( 0, UI.Spacing + 1 )

                        for k, v in pairs( Group.Settings.effect ) do
                            ui:Insert(
                                main:CreateEffectListItem( ui, k, v, Group.Settings.effect_self[ k ] )
                            )

                            main.effect_list_count = main.effect_list_count + 1
                        end

                        ui.thumb:SetHeight( 64 )

                        if main.effect_list_count > 3 then
                            ui.thumb:SetVisible( true )
                        else
                            ui.thumb:SetVisible( false )
                        end

                        ui:AddFiller( 0, UI.Spacing + 1 )

                        UI:Create( "BOX", ui, function( ui )
                            ui:SetSize( 360 - 16 - UI.Spacing / 2, 1 )
                            ui:SetColor( 100, 100, 100 )
                        end )
        
                        UI:Create( "BOX", ui, function( ui )
                            ui:SetSize( 1, 172 )
                            ui:SetColor( 100, 100, 100 )
                        end )
        
                        UI:Create( "BOX", ui, function( ui )
                            ui:SetSize( 360 - 16 - UI.Spacing / 2, 1 )
                            ui:SetPos( 0, 172 - 1 )
                            ui:SetColor( 100, 100, 100 )
                        end )
        
                        UI:Create( "BOX", ui, function( ui )
                            ui:SetSize( 1, 172 )
                            ui:SetPos( 360 - 16 - UI.Spacing / 2 - 1, 0 )
                            ui:SetColor( 100, 100, 100 )
                        end )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                --Button Add and Remove
                ui:AddItem(
                    UI:Create( "BOX", ui, function( ui )
                        ui:SetSize( 360, 16 )
                        ui:SetColor( 0, 0, 0, 0 )
                        ui:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend )

                        UI:Create( "BUTTON", ui, function( ui )
                            ui:SetSize( 100, 16 )
                            ui:SetText( "Add Effect" )

                            function ui:Pressed()
                                if main.effect == nil or main.effect == "" then return end
                                if not ( Group.Settings.effect[ main.effect ] == nil ) then return end

                                Group.Settings.effect[ main.effect ]       = false
                                Group.Settings.effect_self[ main.effect ]  = false
                                Group.Settings.effect_stack[ main.effect ] = 1

                                main.effect_list:Insert(
                                    main:CreateEffectListItem( ui, main.effect ),
                                    main.effect_list:GetItemCount()
                                )

                                main.effect = nil

                                Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                                main.effect_name:SetText( "" )
                                main.effect_text_placeholder:SetVisible( true )

                                main.effect_list_count = main.effect_list_count + 1

                                if main.effect_list_count > 3 then
                                    main.effect_list.thumb:SetVisible( true )
                                end
                            end
                        end )

                        UI:Create( "BUTTON", ui, function( ui )
                            ui:SetSize( 130, 16 )
                            ui:SetPos( 360 - 130 - 10 - UI.Spacing / 2 - 6, 0 )
                            ui:SetText( "Remove Selected" )

                            function ui:Pressed()
                                if main.effect_list.selected then
                                    Group.Settings.effect[ main.effect_list.selected.name ]       = nil
                                    Group.Settings.effect_self[ main.effect_list.selected.name ]  = nil
                                    Group.Settings.effect_stack[ main.effect_list.selected.name ] = nil

                                    Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                                    main.effect_list:Remove( main.effect_list.selected )

                                    main.effect_list.selected = nil

                                    main.effect_list_count = main.effect_list_count - 1

                                    if main.effect_list_count < 4 then
                                        main.effect_list.thumb:SetVisible( false )
                                    end

                                    for i = 1, #Group.Party do
                                        Group.Party[ i ]:RefreshEffects( Group.Party[ i ].player_effects, true )
                                    end
                                end
                            end
                        end )
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXT", ui, function( ui )
                        ui:SetSize( 360, 13 * 2 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 )
                        ui:SetText( "Note: Type the effect name EXACTLY as shown in the effect tooltip on your buffbar!" )
                        ui:SetForeColor( Color( 125, 125, 125 ) )
                    end )
                )

                ui:AddFiller( 0, UI.Spacing )

                ui:AddItem(
                    UI:Create( "TEXTBOX", ui, function( ui )
                        ui:SetSize( 360, 24 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro20 )
                        ui:SetTextAlignment( 5 )
                        ui:SetMultiline( false )
                        ui:SetText( "" ) --"Vethúg's Revenge"

                        main.effect_name = ui

                        function ui:TextChanged()
                            local text = self:GetText()

                            if text == "" then
                                main.effect_text_placeholder:SetVisible( true )
                            else
                                main.effect_text_placeholder:SetVisible( false )
                            end

                            main.effect = text
                        end

                        main.effect_text_placeholder = UI:Create( "TEXT", ui, function( ui )
                            ui:SetSize( 360, 24 )
                            ui:SetText( "Effect Name" )
                            ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro20 )
                            ui:SetForeColor( Turbine.UI.Color( 0.5, 0.5, 0.5 ) )
                            ui:SetTextAlignment( 5 )
                            ui:SetMouseVisible( false )
                            ui:SetZOrder( 50 )
                        end )

                        UI:Create( "BORDER", ui, function( ui )
                            ui:SetSize( 360, 24 )
                            ui:SetBorderSize( 1 )
                            ui:SetBorderColor( Color( 100, 100, 100 ) )
                            ui:SetZOrder( 50 )
                        end )
                    end )
                )

                ui:SetHeightToChildren( 16 )
            end )
        )

        --Special Effect
        main.sideBar:AddItem(
            UI:Create( "LIST", main.sideBar, function( ui )
                ui:SetWidth( 360 )
                ui:SetColor( 0, 200, 0, 0 )
                ui:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend )
                ui:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply )

                ui:AddItem(
                    UI:Create( "HEADER", ui, function( ui )
                        ui:SetText( "Special Effect" )
                    end )
                )

                ui:AddFiller( 0, 16 )

                ui:AddItem(
                    UI:Create( "TEXTBOX", ui, function( ui )
                        ui:SetSize( 360, 24 )
                        ui:SetFont( Turbine.UI.Lotro.Font.TrajanPro20 )
                        ui:SetTextAlignment( 5 )
                        ui:SetMultiline( false )
                        ui:SetText( Group.Settings.special_effect ) --"Vethúg's Revenge"

                        function ui:TextChanged()
                            local text = self:GetText()

                            Group.Settings.special_effect = text

                            Turbine.PluginData.Save( Turbine.DataScope.Character, "MiniRaid_Settings", Group.Settings )

                            for i = 1, #Group.Party do
                                Group.Party[ i ]:RefreshEffects( Group.Party[ i ].player_effects, true )
                            end
                        end

                        UI:Create( "BORDER", ui, function( ui )
                            ui:SetSize( 360, 24 )
                            ui:SetBorderSize( 1 )
                            ui:SetBorderColor( Color( 100, 100, 100 ) )
                            ui:SetZOrder( 50 )
                        end )
                    end )
                )

                ui:SetHeightToChildren()
            end )
        )
    end )
end